define(['app'], function(app){
    "use strict";

	    return app.controller("LanguagesCtrl", LanguagesCtrl);
            
                $rootScope.lang = {};
                
                var buildCh = function (items) {
                    var ul = "<ul>";
                    angular.forEach(items, function(i){            
                        var li = '<li data-ui-sref-active="active">';                
                        li += '<a data-ui-sref="'+i.nome+'"><i class="'+i.icon+'"></i> '+$rootScope.getWord(i.descricao)+'</a>';
                        li += '</li>';
                        ul += li;
                    });
                    ul += "</ul>";
                    return ul;
                };

                var buildMenu = function (items) { 

                    var ul = '<aside id="left-panel"><nav><ul data-smart-menu>';
                    angular.forEach(items, function(i){                            
                        var li = "<li data-menu-collapse>";
                        if(i.nome){
                            li += '<a data-ui-sref="'+i.nome+'"><i class="'+i.icon+'"></i> <span class="menu-item-parent"> '+$rootScope.getWord(i.descricao)+'</span></a>';                
                        }
                        else {
                            li += '<a href="#"><i class="'+i.icon+'"></i> <span class="menu-item-parent"> '+$rootScope.getWord(i.descricao)+'</span></a>';                
                        }
                        li += buildCh(i.modulos);                
                        li += "</li>";
                        ul += li;
                    });
                    ul += "</ul>";
                    ul += "</nav>";
                    ul += '<span class="minifyme" data-action="minifyMenu" minify-menu>';
                    ul += '<i class="fa fa-arrow-circle-left hit"></i>';
                    ul += '</span>';
                    ul += '</aside>';

                    return ul;
                };

			function LanguagesCtrl($scope, $rootScope, $log, Language){

				$rootScope.lang = {};
				
				Language.getLanguages(function(data){

                    $rootScope.currentLanguage = data[0];

                    $rootScope.languages = data;

                    Language.getLang(data[0].key,function(data){

                    	$rootScope.lang = data;
                    });

                });

				$scope.selectLanguage = function(language){
                    $rootScope.currentLanguage = language;
                    
                    Language.getLang(language.key,function(data){

                    	$rootScope.lang = data;
                        
                    });
                }


                $rootScope.getWord = function(key){
                	if(angular.isDefined($rootScope.lang[key])){
                		return $rootScope.lang[key];
                	} 
                	else {
                		return key;
                	}
                }

			}

});