define(['app'], function(app){
    "use strict";

	    return app.controller("LanguagesCtrl", LanguagesCtrl);

		function LanguagesCtrl($scope, $rootScope, Language, User, $localStorage, $window){
                                
		$rootScope.lang = {};
                
                var buildCh = function (items) {
                    var ul = "<ul>";
                    angular.forEach(items, function(i){            
                        var li = '<li data-ui-sref-active="active">';                
                        li += '<a data-ui-sref="'+i.nome+'"><i class="'+i.icon+'"></i> '+$rootScope.getWord(i.descricao)+'</a>';
                        li += '</li>';
                        ul += li;
                    });
                    ul += "</ul>";
                    return ul;
                };

                var buildMenu = function (items) { 

                    var ul = '<aside id="left-panel"><nav><ul data-smart-menu>';
                    angular.forEach(items, function(i){                            
                        var li = "<li data-menu-collapse>";
                        if(i.nome){
                            li += '<a data-ui-sref="'+i.nome+'"><i class="'+i.icon+'"></i> <span class="menu-item-parent"> '+$rootScope.getWord(i.descricao)+'</span></a>';                
                        }
                        else {
                            li += '<a href="#"><i class="'+i.icon+'"></i> <span class="menu-item-parent"> '+$rootScope.getWord(i.descricao)+'</span></a>';                
                        }
                        li += buildCh(i.modulos);                
                        li += "</li>";
                        ul += li;
                    });
                    ul += "</ul>";
                    ul += "</nav>";
                    ul += '<span class="minifyme" data-action="minifyMenu" minify-menu>';
                    ul += '<i class="fa fa-arrow-circle-left hit"></i>';
                    ul += '</span>';
                    ul += '</aside>';

                    return ul;
                };
				
		Language.getLanguages(function(data){
                    console.log($localStorage.currentLanguage);
                    if(angular.isDefined($localStorage.currentLanguage)){
                        $rootScope.currentLanguage = $localStorage.currentLanguage;
                        for( var i in data) {
                            if($localStorage.currentLanguage.key === data[i].key){
                                break;
                            }
                        }
                    }
                    else {
                        for( var i in data) {
                            if(options.api.lang === data[i].key){
                                $localStorage.currentLanguage = data[i];
                                $rootScope.currentLanguage = data[i];
                                break;
                            }
                        }
                    }

                    $rootScope.languages = data;

                    Language.getLang(data[i].key,function(data){
                        $localStorage.lang = data;
                    });

                });

		$scope.selectLanguage = function(language){
                    $localStorage.currentLanguage = language;
                    
                    Language.getLang(language.key,function(data){
                        $localStorage.lang = data;
                        
                        $localStorage.User.menu = buildMenu(User.modulos);
                        
                        $window.location.reload();
                    });
                    
                    
                }


                $rootScope.getWord = function(key){
                	if(angular.isDefined($localStorage.lang[key])){
                		return $localStorage.lang[key];
                	} 
                	else {
                		return key;
                	}
                }

			}

});