define(['layout/module'], function (module) {

    "use strict";

    module.registerDirective('resetWidgets', function ($state, $http, $localStorage) {

        return {
            restrict: 'A',
            link: function (scope, element) {
                element.on('click', function () {
                    $.SmartMessageBox({
                        title: "<i class='fa fa-refresh' style='color:green'></i> Limpar perfil",
                        content: "Esse procedimento irá remover todas as suas personalizações, tem certeza que gostária de fazer isso?",
                        buttons: '[Não][Sim]'
                    }, function (ButtonPressed) {
                        if (ButtonPressed == "Sim" && localStorage) {
                            if ($localStorage.User) {
                                $http.put(`${options.api.restv4}/logoff/supervisor/${$localStorage.User.id}`)
                                    .success(function (data) {
                                        console.log('logOff efetuado');
                                        localStorage.clear();
                                        location.reload();
                                    });
                            }
                            else {
                                localStorage.clear();
                                location.reload();
                            }
                        }
                    });

                });
            }
        }

    })

});
