define([
    'angular',
    'angular-couch-potato',
    'lodash',
    'angular-ui-router',
    'angular-resource',
    'ngTagsInput',
    'underscore',
    'jspdf',
    'autotable'
], function (ng, couchPotato, _) {
    'use strict';

    var module = ng.module('app.atendchat', [
        'ui.router',
        'ngResource',
        'ngTagsInput'
    ]);


    couchPotato.configureApp(module);

    module.config(function ($stateProvider, $couchPotatoProvider) {

        $stateProvider
            .state('app.atendchat', {
                url: '/atendimentochat',
                data: {
                    title: 'Atendimentos de Chats',
                    permissions: {
                        only: ['app.atendchat']
                    }
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/atendimentochat/views/lista.html',
                        controller: 'atendChatCtrl',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/atendimentochat/controllers/atendChatCtrl',
                                'modules/atendimentochat/directives/atendChatFormValidate',
                                'modules/ui/directives/smartProgressbar',
                                'modules/forms/directives/input/smartDatepicker',
                                'modules/forms/directives/input/smartTimepicker',
                                'modules/forms/directives/input/smartClockpicker'
                            ])
                        },
                    }
                }
            })
    });

    module.run(function ($couchPotato,Permission,$localStorage,ModuloPermissao) {
        module.lazy = $couchPotato;
        Permission.defineRole('app.atendchat', function () {
            if(!$localStorage.User || !ModuloPermissao.UsuarioTemModulo("app.atendchat",$localStorage.User.modulos)){
               $localStorage.msg = {
                   tipo: "Erro",
                   txt: "Você não tem acesso ao relatório de atendimentos de chats."
               };
               return false;
            }
            else {
                return true;
            }
        });
    });


    return module;

});
