define([
    'angular',
    'angular-couch-potato',
    'lodash',
    'angular-ui-router',
    'angular-resource',
    'isteven-multi-select',
    'ngTagsInput',
    'bootstrap-toggle'

], function (ng, couchPotato, _) {
    'use strict';

    var module = ng.module('app.autocomplete', [
        'ui.router',
        'ngResource',
        'isteven-multi-select',
        'ngTagsInput',
        'toggle-switch'
    ]);


    couchPotato.configureApp(module);

    module.config(function ($stateProvider, $couchPotatoProvider) {

        $stateProvider
            .state('app.autocomplete', {
                url: '/autocomplete',
                data: {
                    title: 'autocomplete',
                    permissions: {
                        only: ['app.autocomplete']
                    }
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/autocomplete/views/lista.html',
                        controller: 'AutocompleteCtrl',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/autocomplete/controllers/AutocompleteCtrl',                                
                                'modules/forms/directives/input/smartTimepicker',
                                'modules/forms/directives/input/smartClockpicker'
                            ])
                        }
                    }
                }
            })
    });

    module.run(function ($couchPotato,Permission,$localStorage,ModuloPermissao) {
        module.lazy = $couchPotato;
        Permission.defineRole('app.autocomplete', function () {
            if(!$localStorage.User || !ModuloPermissao.UsuarioTemModulo("app.autocomplete",$localStorage.User.modulos)){
               $localStorage.msg = {
                   tipo: "Erro",
                   txt: "Você não tem acesso ao Autocomplete."
               };
               return false;
            }
            else {
                return true;
            }
        });
    });

    return module;

});
