define([
    'angular',
    'angular-couch-potato',
    'lodash',
    'angular-ui-router',
    'angular-resource',
    'ng-csv',
    'raphael',
    'jusgage',
    'highcharts',
    'highcharts-export',
    'angular-highcharts',
    'ngTagsInput'
], function (ng, couchPotato, _) {
    'use strict';

    var module = ng.module('app.campanha_importacao', [
        'ui.router',
        'ngResource',
        'ngCsv',
        'easypiechart',
        'highcharts-ng',
        'ngTagsInput'
    ]);


    couchPotato.configureApp(module);

    module.config(function ($stateProvider, $couchPotatoProvider) {

        $stateProvider
            .state('app.campanha_importacao', {
                url: '/campanha_importacao',                
                data: {
                    title: 'Parâmetros de importação',
                    permissions: {
                        only: ['app.campanha_importacao']
                    }
                },                
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/campanha_importacao/views/form.html',
                        controller: 'CampanhaImportacaoCtrl',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/campanha_importacao/controllers/CampanhaImportacaoCtrl',
                                'modules/campanha_importacao/directives/campanhaImportacaoFormValidate',
                                'modules/forms/directives/input/smartDatepicker',
                                'modules/forms/directives/input/smartTimepicker',
                                'modules/forms/directives/input/smartClockpicker'
                            ])
                        },                        
                    }
                }
            })
    });

    module.run(function ($couchPotato,Permission,$localStorage,ModuloPermissao) {
        module.lazy = $couchPotato;        
        Permission.defineRole('app.campanha_importacao', function () {
            if(!$localStorage.User || !ModuloPermissao.UsuarioTemModulo("app.campanha_importacao",$localStorage.User.modulos)){
               $localStorage.msg = {
                   tipo: "Erro",
                   txt: "Você não tem acesso ao modulo de importações."
               };               
               return false;
            }            
            else {                
                return true;         
            }
        });
    });


    return module;

});