define(['modules/campanhas/module'], function (module) {
    "use strict";

    return module.registerController('FilaCtrl', function ($scope, $http, Upload, $timeout, $stateParams, $filter, $rootScope) {
        $scope.carregando = false;
        $scope.filtro = {};
        $scope.order = [{ "campo": "id", "ordem": "ASC" }];

        $scope.Limpa = function (r) {
            return JSON.stringify(r).replace(/[&\/\\#\[\]+()$~%.'"*?<>{}]/g, '').replace(',', ', ');
        };

        $scope.getCampos = function (r) {
            var ret = [];
            angular.forEach(r, function (campo) {
                for (var x in campo) {
                    if (x.toString().toLocaleLowerCase() === 'nome' ||
                        x.toString().toLocaleLowerCase() === 'cpf' ||
                        x.toString().toLocaleLowerCase() === 'cnpj' ||
                        x.toString().toLocaleLowerCase() === 'id' ||
                        x.toString().toLocaleLowerCase() === 'codigo') {
                        ret.push(x + ': ' + campo[x].replace(/[&\/\\#\[\]+()$~%.'"*?<>{}]/g, ''));
                    }
                }
            });
            return ret.length > 0 ? ret.join(', ') : JSON.stringify(r).replace(/[&\/\\#\[\]+()$~%.'"*?<>{}]/g, '').replace(',', ', ');
        };

        $scope.Limpa2 = function (r) {
            return r.replace(/[^\w ]/g, '');
        };

        $scope.getIndex = function (index) {
            return $scope.filtro.page ? ($scope.filtro.page.valor - 1) * 15 + index : index;
        };

        $scope.gotoPage = function (page) {
            $scope.filtro.page = { valor: page };
            $scope.load();
        };

        /**
         * Carrega dados da lista
         * @returns void
         */
        $scope.load = function () {
            $scope.table = undefined;
            $scope.carregando = true;
            var par = [];
            if ($scope.filtro) {
                angular.forEach($scope.filtro, function (v, k) {
                    if (v) par.push(k + "=" + v.valor);
                });
            }
            var pars = "";
            if (par.length > 0) {
                pars = "&" + par.join("&");
            }
            $http.get(options.api.restv2 + "/campanha/" + $stateParams.campanha + "/fila_discagem?max=15" + pars)
                .success(function (data) {
                    // Ordena a lista pela prioridade do contato
                    // if (data && data.dados && data.dados.length > 0) data.dados = data.dados.sort((a, b) => b.prioridade - a.prioridade);

                    $scope.table = data;
                    $scope.carregando = false;
                });
        };

        $scope.ToCSV = function () {
            $scope.exportando_csv = true;
            return $http.get(options.api.restv2 + "/campanha/" + $stateParams.campanha + "/fila_discagem?max=-1")
                .then(res =>{
                    //console.log(res);
                    var arr = [];
                    var cab = {
                        index: '#',
                        numero: 'Numero',
                        numero_nome: 'Numero Nome',
                        tentativas: 'Tentativas',
                        retentativas: 'Retentativas',
                        campos: 'Campos'
                    };
                    arr.push(cab);

                    for (var i in res.data.dados) {
                        var a1 = {
                            index: (parseInt(i) + 1),
                            numero: res.data.dados[i].numero,
                            numero_nome: $scope.Limpa2(res.data.dados[i].nome),
                            tentativas: res.data.dados[i].tentativas,
                            retentativas: res.data.dados[i].retentativas,
                            campos: $scope.getCampos(res.data.dados[i].campos),
                        };
                        arr.push(a1);
                    }
                    $scope.exportando_csv = false;
                    return arr;
                });
        };

        $scope.Voltar = function () {
            $rootScope.$state.transitionTo('app.campanhas');
        };

        $scope.$watch('Pesquisa', function (t1, t2) {
            // Se os dois valores estirem em branco nao faz nada, isso aconte no load.
            if (!t1 && !t2)
                return false;

            setTimeout(function () {
                if (t1 === $scope.Pesquisa) {
                    if (t1 !== '') {
                        $scope.filtro.nome = { valor: t1 };
                    }
                    else {
                        $scope.filtro.nome = undefined;
                    }

                    $scope.load();
                }
            }, 1000);
        });

        $scope.getClass = function (coluna) {
            if ($scope.order[0].campo === coluna) {
                return $scope.order[0].ordem === 'ASC' ? 'sorting_asc' : 'sorting_desc';
            }
            else {
                return 'sorting';
            }
        };

        $scope.setOrder = function (coluna) {
            if ($scope.order[0].campo === coluna) {
                $scope.order[0].ordem = $scope.order[0].ordem === 'ASC' ? 'DESC' : 'ASC';
            }
            else {
                $scope.order = [{ "campo": coluna, "ordem": "ASC" }];
            }
            //console.log($scope.order);
            $scope.load();
        };
    });
});
