define([
    'angular',
    'angular-couch-potato',
    'lodash',
    'angular-ui-router',
    'angular-resource'

], function (ng, couchPotato, _) {
    'use strict';

    var module = ng.module('app.classificacoes2', [
        'ui.router',
        'ngResource'
    ]);


    couchPotato.configureApp(module);

    module.config(function ($stateProvider, $couchPotatoProvider) {

        $stateProvider
            .state('app.classificacoes2', {
                url: '/classificacoes2',                
                data: {
                    title: 'Classificações2',
                    permissions: {
                        only: ['app.classificacoes2']
                    }
                },                
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/classificacoes2/views/lista.html',
                        controller: 'Classificacoes2Ctrl',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/classificacoes2/controllers/Classificacoes2Ctrl'
                            ])
                        },                        
                    }
                }
            })
            
            .state('app.classificacoes2.editar', {
                url: '/editar/:id',
                data: {
                    title: 'Classificação2',
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/classificacoes2/views/form.html',
                        controller: 'Classificacoes2Ctrl',
                        parent: 'app.classificacoes2',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/classificacoes2/controllers/Classificacoes2Ctrl',
                                'modules/classificacoes2/directives/classificacoes2FormValidate'
                            ])
                        }
                    }
                }
            })
            
            .state('app.classificacoes2.novo', {
                url: '/novo',
                data: {
                    title: 'Nova Classificação',
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/classificacoes2/views/form.html',
                        controller: 'Classificacoes2Ctrl',
                        parent: 'app.classificacoes2',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/classificacoes2/controllers/Classificacoes2Ctrl',
                                'modules/classificacoes2/directives/classificacoes2FormValidate'
                            ])
                        }
                    }
                }
            })
            
            .state('app.classificacoes2.ver', {
                url: '/ver/:id',
                data: {
                    title: 'Classificação',
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/classificacoes2/views/form.html',
                        controller: 'Classificacoes2Ctrl',
                        parent: 'app.classificacoes2',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/classificacoes2/controllers/Classificacoes2Ctrl',
                                'modules/classificacoes2/directives/classificacoes2FormValidate'
                            ])
                        }
                    }
                }
            })
    });

    module.run(function ($couchPotato,Permission,$localStorage,ModuloPermissao) {
        module.lazy = $couchPotato;        
        
        Permission.defineRole('app.classificacoes2', function () {
            if(!$localStorage.User || !ModuloPermissao.UsuarioTemModulo("app.classificacoes2",$localStorage.User.modulos)){
               $localStorage.msg = {
                   tipo: "Erro",
                   txt: "Você não tem acesso ao módulo de Classificações."
               };               
               return false;
            }            
            else {                
                return true;         
            }
        });
    });

    return module;

});