define(['modules/clientes/module'], function (module) {
    "use strict";

    return module.registerController('ClienteGruposCtrl', function ($scope, $http, $stateParams, $rootScope, $state) {
        $scope.filtro = {};
        $scope.order = [{ "campo": "nome", "ordem": "asc" }];

        $scope.Edit = (e) => {
            getfilas();
            $scope.popup = angular.copy(e);
            $scope.showEdit = true;
        }

        $scope.New = () => {
            getfilas();
            $scope.popup = {};
            $scope.showEdit = true;
        }

        function getfilas() {
            $http.get(options.api.restv2 + "/filas?max=-1").
                success(function (data) {
                    $scope.filas = data.dados;
                });
        };

        $scope.getGrupos = function (callback, max) {
            if (!max) max = 15;
            var filtros = angular.copy($scope.filtro);
            if (filtros.ordenar && filtros.ordenar.length > 0) {
                delete filtros.ordenar;
                $scope.order = [];
                angular.forEach($scope.filtro.ordenar, function (o) {
                    $scope.order.push({ "campo": o.valor, "ordem": "ASC" });
                });
            }
            else {
                delete filtros.ordenar;
            }

            var par = [];
            angular.forEach(filtros, function (v, k) {
                if (v) par.push(k + "=" + encodeURI(v));
            });
            var pars = "";
            if (par.length > 0) {
                pars = "&" + par.join("&");
            }
            $http.get(options.api.restv2 + "/clientesGrupos?max=" + max + "&order=" + encodeURI(JSON.stringify($scope.order)) + pars).
                then(function (d) {
                    callback(d.data);
                });
        }

        $scope.gotoPage = function (page) {
            $scope.filtro.page = page;
            $scope.load();
        };

        // Chamada para primeira pagina
        $scope.load = function () {
            $scope.loading = true;
            $scope.getGrupos((data) => {
                $scope.table = data;
                $scope.loading = false;
            })
        };

        $scope.Salvar = function (f) {
            if (f.$valid) {
                var pop = angular.copy($scope.popup);

                if (pop.id) {
                    delete pop.id;
                    $http.put(options.api.restv2 + "/clientesGrupos/" + $scope.popup.id, pop).
                        success(function (data) {
                            $.smallBox({
                                title: "SUCESSO!!",
                                content: "<i class='fa fa-check'></i> <i>Salvo com sucesso!</i>",
                                color: "#739E73",
                                timeout: 2000
                            });
                            $scope.showEdit = false;
                            $scope.load();
                        });
                }
                else {
                    $http.post(options.api.restv2 + "/clientesGrupos", pop).
                        success(function (data) {
                            $.smallBox({
                                title: "SUCESSO!!",
                                content: "<i class='fa fa-check'></i> <i>Salvo com sucesso!</i>",
                                color: "#739E73",
                                timeout: 2000
                            });
                            $scope.showEdit = false;
                            $scope.load();
                        });
                }
            }
        };

        $scope.confirma = function (row) {
            $.x5Box({
                title: "Remover <b>" + row.nome + "</b>?",
                content: "Tem certeza que quer remover " + row.nome + "? <p class='text-align-right'><a id='yes' href-void class='btn btn-danger btn-sm btncallback'>Apagar</a> <a id='no' href-void class='btn btn-primary btn-sm btncallback'>Cancelar</a></p>",
                color: "#C46A69",
                //timeout: 8000,
                icon: "fa fa-warning shake animated"
            }, function (ButtonPressed) {
                if (ButtonPressed === "Apagar") {
                    $scope.delete(row.id);
                }
            });
        };

        $scope.delete = function (id) {
            $http.delete(options.api.restv2 + "/clientesGrupos/" + id).
                success(function (s) {
                    $.smallBox({
                        title: "SUCESSO!!",
                        content: "<i class='fa fa-check'></i> <i>Apagado com sucesso!</i>",
                        color: "#739E73",
                        timeout: 2000
                    });
                    $scope.load();
                })
        };
    });
});