define(['modules/clientes/module'], function (module) {
    "use strict";

    return module.registerController('ClienteLayoutsCtrl', function ($scope, $http) {
        $scope.filtro = {};
        $scope.order = [{ "campo": "nome", "ordem": "ASC" }];

        $scope.reservados = [
            { valor: 'nome', nome: 'nome' },
            { valor: 'numero', nome: 'Número' },
            { valor: 'email', nome: 'Email' },
            { valor: 'isBusiness', nome: 'Tipo de pessoa' },
            { valor: 'documento', nome: 'Documento' },
            { valor: 'url', nome: 'URL Integração' },
            { valor: 'facebookID', nome: 'ID do facebook' },
            { valor: 'telefone_adicional', nome: 'Telefone adicional' },
            { valor: 'campo_adicional', nome: 'Campo adicional' },
        ];

        $scope.gotoPage = function (page) {
            $scope.filtro.page = page ? page : 1;
            $scope.load();
        };

        // Chamada para primeira pagina
        $scope.load = function () {
            var par = [];
            if ($scope.filtro.page == undefined) delete $scope.filtro.page;
            if ($scope.filtro) {
                angular.forEach($scope.filtro, function (v, k) {
                    if (v) par.push(k + "=" + v.valor);
                });
            }
            var pars = "";
            if (par.length > 0) {
                pars = "&" + par.join("&");
                console.log(pars);
            }
            $scope.loading = true;
            $http.get(options.api.restv2 + "/layouts?max=15&modulo=clientes&order=" + encodeURI(JSON.stringify($scope.order) + pars)).
                success(function (data) {
                    $scope.table = data;
                    $scope.loading = false;
                });
        };

        $scope.showedit = function (row) {
            $scope.layout = angular.copy(row);
            $scope.layout.modulo = "clientes";
            var order = [{ "campo": "posicao_csv", "ordem": "ASC" }];
            $http.get(options.api.restv2 + "/layout/" + $scope.layout.id + "/campos?max=-1&order=" + encodeURI(JSON.stringify(order))).
                success(function (data) {
                    for (var i = 0; i < data.dados.length; ++i) {
                        delete data.dados[i].id;
                        delete data.dados[i].id_layout;
                    }
                    $scope.layout.campos = data.dados;
                    $scope.showEdit = true;
                });
        };

        $scope.shownew = function () {
            $scope.layout = {};
            $scope.layout.delimitador = ";";
            $scope.layout.modulo = "clientes";
            $scope.layout.cabecalho = true;
            $scope.layout.campos = [];
            $scope.layout.campos.push({ nome: '', posicao_csv: '', xcontact: '' });
            $scope.showEdit = true;
        };

        $scope.Save = function (f1) {
            if (f1.$valid) {
                var layout = angular.copy($scope.layout);
                delete layout.campos;
                delete layout.id;
                if ($scope.layout.id) {
                    $http.put(options.api.restv2 + "/layout/" + $scope.layout.id, layout).
                        success(function (data) {
                            // Se deu sucesso atualiza os campos
                            if ($scope.layout.campos) {
                                //var campos = angular.copy($scope.layout.campos);
                                for (var i = 0; i < $scope.layout.campos.length; ++i) {
                                    if (!$scope.layout.campos[i].xcontact) $scope.layout.campos[i].xcontact = null;
                                }
                                $http.put(options.api.restv2 + "/layout/" + $scope.layout.id + "/campos", $scope.layout.campos).
                                    success(function (data) {
                                        $scope.load();
                                        $scope.showEdit = false;
                                        $.smallBox({
                                            title: $scope.getWord('SUCESSO') + "!!",
                                            content: "<i class='fa fa-check'></i> <i>Layout atualizado com sucesso!</i>",
                                            color: "#739E73",
                                            timeout: 2000
                                        });
                                    });
                            }
                        });
                }
                else {
                    $http.post(options.api.restv2 + "/layout", layout).
                        success(function (data) {
                            // Se deu sucesso atualiza os campos
                            if ($scope.layout.campos) {
                                //var campos = angular.copy($scope.layout.campos);
                                for (var i = 0; i < $scope.layout.campos.length; ++i) {
                                    if (!$scope.layout.campos[i].xcontact) $scope.layout.campos[i].xcontact = null;
                                }
                                $http.put(options.api.restv2 + "/layout/" + data.id + "/campos", $scope.layout.campos).
                                    success(function (data) {
                                        $scope.load();
                                        $scope.showEdit = false;
                                        $.smallBox({
                                            title: $scope.getWord('SUCESSO') + "!!",
                                            content: "<i class='fa fa-check'></i> <i>Layout atualizado com sucesso!</i>",
                                            color: "#739E73",
                                            timeout: 2000
                                        });
                                    });
                            }
                        });
                }
            }
            else {
                alert($scope.getWord('Existem campos obrigatórios não preenchidos.'));
                console.log(f1);
            }
        };

        $scope.$watch('Pesquisa', function (t1, t2) {
            // Se os dois valores estirem em branco nao faz nada, isso aconte no load.
            if (!t1 && !t2)
                return false;

            setTimeout(function () {
                if (t1 === $scope.Pesquisa) {
                    if (t1 !== '') {
                        $scope.filtro.nome = { valor: t1 };
                    }
                    else {
                        delete $scope.filtro.nome;
                    }
                    $scope.load();
                }
            }, 1000);
        });

        $scope.confirma = function (row) {
            $.x5Box({
                title: "Remover <b>" + row.nome + "</b>?",
                content: "Tem certeza que quer remover " + row.nome + "? <p class='text-align-right'><a id='yes' href-void class='btn btn-danger btn-sm btncallback'>Apagar</a> <a id='no' href-void class='btn btn-primary btn-sm btncallback'>Cancelar</a></p>",
                color: "#C46A69",
                //timeout: 8000,
                icon: "fa fa-warning shake animated"
            }, function (ButtonPressed) {
                if (ButtonPressed === "Apagar") {
                    $scope.delete(row.id);
                }
            });
        };

        $scope.delete = function (id) {
            $http.delete(options.api.restv2 + "/layout/" + id).
                success(function (s) {
                    $.smallBox({
                        title: "SUCESSO!!",
                        content: "<i class='fa fa-check'></i> <i>Layout apagado com sucesso!</i>",
                        color: "#739E73",
                        timeout: 6000
                    });

                    $scope.load();
                })
        };

        $scope.AddItem = function () {
            $scope.layout.campos.push({ nome: '', posicao_csv: '', xcontact: '' });
        };

        $scope.DelItem = function (index) {
            $scope.layout.campos.splice(index, 1);
        }
    });
});