define([
    'angular',
    'angular-couch-potato',
    'lodash',
    'angular-ui-router',
    'angular-resource'

], function (ng, couchPotato, _) {
    'use strict';

    var module = ng.module('app.configuracoes_pesquisa_satisfacao', [
        'ui.router',
        'ngResource'
    ]);


    couchPotato.configureApp(module);

    module.config(function ($stateProvider, $couchPotatoProvider) {

        $stateProvider
            .state('app.configuracoes_pesquisa_satisfacao', {
                url: '/configuracoes/pesquisa_satisfacao',                
                data: {
                    title: 'Pesquisa de Satisfação',
                    permissions: {
                        only: ['app.configuracoes_pesquisa_satisfacao']
                    }
                },                
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/configuracoes/pesquisa_satisfacao/views/lista.html',
                        controller: 'PesquisaSatisfacaoCtrl',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/configuracoes/pesquisa_satisfacao/controllers/PesquisaSatisfacaoCtrl',
                                'modules/configuracoes/pesquisa_satisfacao/directives/pesquisaPopup'
                            ])
                        },                        
                    }
                }
            })
    });

    module.run(function ($couchPotato,Permission,$localStorage,ModuloPermissao) {
        module.lazy = $couchPotato;        
        Permission.defineRole('app.configuracoes_pesquisa_satisfacao', function () {
            if(!$localStorage.User || !ModuloPermissao.UsuarioTemModulo("app.configuracoes_pesquisa_satisfacao",$localStorage.User.modulos)){
               $localStorage.msg = {
                   tipo: "Erro",
                   txt: "Você não tem acesso ao módulo de Configurações de Pesquisas de Satisfações."
               };               
               return false;
            }            
            else {                
                return true;         
            }
        });
    });

    return module;

});