define([
    'angular',
    'angular-couch-potato',
    'angular-ui-router',
    'angular-resource',
    'angular-easypie',
    'angular-ws',
    'raphael',
    'jusgage',
    'highcharts',
    'angular-highcharts',
    'ngTagsInput',
    'moment',
    'moment-br',
    'moment-timezone',
    'ui.bootstrap',
    'angular-socket-io'
], function (ng, couchPotato) {
    'use strict';

    var module = ng.module('app.dashboards.online', [
        'ui.router',
        'ngResource',
        'easypiechart',
        'ws',
        'highcharts-ng',
        'ngTagsInput',
        'ui.bootstrap',
        'btford.socket-io'
    ]);

    couchPotato.configureApp(module);

    module.config(function ($stateProvider, $couchPotatoProvider) {

        $stateProvider
            .state('app.dashboards.online', {
                url: '/dashboards/online',
                data: {
                    title: 'Online'
                },
                views: {
                    "content@app": {
                        controller: 'OnlineCtrlNew',
                        templateUrl: 'app/modules/painelsupervisor/view/newonline.html',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/painelsupervisor/controllers/OnlineCtrlNew',
                                'modules/painelsupervisor/model/Fila',
                                'modules/painelsupervisor/model/Agente',
                                'modules/painelsupervisor/model/Ligacao',
                                'modules/x5graficos/directives/justGage',
                                'modules/graphs/directives/inline/sparklineContainer'
                            ])
                        }
                    }
                }
            })
    });

    module.run(function ($couchPotato, Permission, $localStorage, ModuloPermissao) {
        module.lazy = $couchPotato;
        Permission.defineRole('app.painelsupervisor', function () {
            if (!$localStorage.User || !ModuloPermissao.UsuarioTemModulo("app.painelsupervisor", $localStorage.User.modulos)) {
                $localStorage.msg = {
                    tipo: "Erro",
                    txt: "Você não tem acesso as paineis."
                };
                return false;
            }
            else {
                return true;
            }
        });
    });

    return module;
});
