define([
    'angular',
    'angular-couch-potato',
    'lodash',
    'angular-ui-router',
    'angular-resource',
    'ngTagsInput',
    'ng-csv',
    'highcharts-gauge'
], function (ng, couchPotato, _) {
    'use strict';

    var module = ng.module('app.dashboards_pesquisa_satisfacao', [
        'ui.router',
        'ngResource',
        'ngTagsInput',
        'ngCsv',
        'highChartGauge'
    ]);


    couchPotato.configureApp(module);

    module.config(function ($stateProvider, $couchPotatoProvider) {

        $stateProvider
            .state('app.dashboards_pesquisa_satisfacao', {
                url: '/dashboards/pesquisa_satisfacao',
                data: {
                    title: 'Pesquisa de Satisfação',
                    permissions: {
                        only: ['app.dashboards_pesquisa_satisfacao']
                    }
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/dashboards/pesquisa_satisfacao/views/lista.html',
                        controller: 'PesquisaSatisfacaoCtrl',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/dashboards/pesquisa_satisfacao/controllers/PesquisaSatisfacaoCtrl',
                                'modules/forms/directives/input/smartColorpicker',
                                'modules/forms/directives/input/smartDatepicker',
                                'modules/forms/directives/input/smartTimepicker',
                                'modules/forms/directives/input/smartClockpicker',
                                'util/time',
                                'util/util'
                            ])
                        },
                    }
                }
            })
    });

    module.run(function ($couchPotato, Permission, $localStorage, ModuloPermissao) {
        module.lazy = $couchPotato;
        Permission.defineRole('app.dashboards_pesquisa_satisfacao', function () {
            if (!$localStorage.User || !ModuloPermissao.UsuarioTemModulo("app.dashboards_pesquisa_satisfacao", $localStorage.User.modulos)) {
                $localStorage.msg = {
                    tipo: "Erro",
                    txt: "Você não tem acesso ao módulo de Dashboards de Pesquisas de Satisfações."
                };
                return false;
            }
            else {
                return true;
            }
        });
    });

    return module;

});