"use strict";
define(['modules/fontes_autenticacao/module'], function (module) {
    return module.registerController('FontesautenticacaoCtrl', function ($scope, $http) {
        $scope.sortBy = 'nome';
        $scope.sortDescending = false;
        $scope.searchText = '';
        $scope.isNew = false;

        $scope.order = function (keyname, frist) {
            if (!frist) {
                $scope.sortBy = keyname;
                $scope.sortDescending = !$scope.sortDescending;
            }

            $scope.filteredRT.sort(function (a, b) {
                var sortBy = $scope.sortBy;
                if (a[sortBy] < b[sortBy]) {
                    return $scope.sortDescending ? 1 : -1;
                }
                if (a[sortBy] > b[sortBy]) {
                    return $scope.sortDescending ? -1 : 1;
                }
                return 0;
            });
        };

        $scope.getClass = function (coluna) {
            if ($scope.sortBy === coluna) {
                return $scope.sortDescending ? 'sorting_asc' : 'sorting_desc';
            }
            else {
                return 'sorting';
            }
        };

        $scope.filter = function () {
            $scope.filteredRT = JSON.parse(JSON.stringify($scope.reminderTypes));
            if ($scope.searchText && $scope.searchText.length > 0) {
                $scope.filteredRT = filterIt($scope.filteredRT, $scope.searchText);
            }
        };

        // Chamada para primeira pagina
        $scope.load = function () {
            $scope.carregando = true;
            $http.get(`${options.api.restv4}/autenticacao_fontes`).
                success(function (data) {
                    if (data) {
                        data = data.map(d => {
                            d.ativo = d.ativo ? $scope.getWord('Ativado') : $scope.getWord('Desativado');
                            return d;
                        })
                        $scope.reminderTypes = data;
                        $scope.filteredRT = JSON.parse(JSON.stringify($scope.reminderTypes));
                        $scope.order(null, true);
                    }
                    $scope.carregando = false;
                });
        };

        $scope.novo = async () => {
            $scope.isNew = false;
            $scope.novo_load = true;
            let ti = await $http.get(`${options.api.restv4}/autenticacao_fontes/tipos`);
            $scope.tipos = ti.data;

            $scope.novo_load = false;
            $scope.popup = {};
            $scope.popup.ativo = false;
            $scope.showFontesPopup = true;
        }

        $scope.editar = async (row) => {
            $scope.isNew = false;
            row.load = true;

            let ti = await $http.get(`${options.api.restv4}/autenticacao_fontes/tipos`);
            $scope.tipos = ti.data;

            let t = await $http.get(`${options.api.restv4}/autenticacao_fonte/${row.id}`);
            $scope.popup = t.data;
            //$scope.popup.config = JSON.stringify($scope.popup.config, null, 2);

            $scope.popup.config = Object.entries($scope.popup.config).map(conf => {
                return {
                    parametro: conf[0],
                    valor: conf[1]
                }
            });

            row.load = false;
            $scope.showFontesPopup = true;
        }

        $scope.showTeste = async (row) => {
            $scope.pop = {};
            $scope.pop.config = Object.entries(row.config).map(conf => {
                return {
                    parametro: conf[0],
                    valor: conf[1]
                }
            });

            switch (row.tipo) {
                case 2:
                    $scope.showLdapPopup = true;
                    break;
                default:
                    break;
            }
        }

        $scope.TesteLDAP = async (f) => {
            if (f.$valid) {
                let dados = JSON.parse(JSON.stringify($scope.pop));
                delete dados.id;
                delete dados.autenticacaoTipos;
                delete dados.load;
                delete dados.retorno;

                dados.config = {};
                for (let i = 0; i < $scope.pop.config.length; ++i) {
                    let ob = $scope.pop.config[i];
                    dados.config[ob.parametro] = ob.valor;
                }
                $scope.pop.load = true;
                try {
                    let d = await $http.post(`${options.api.restv4}/autenticacao_fonte/ldapteste`, dados);
                    $scope.pop.load = false;
                    $scope.pop.retorno = JSON.stringify(d.data, null, 2);
                    $.smallBox({
                        title: "SUCESSO!!",
                        content: `<i class='fa fa-check'></i> <i>${$scope.getWord('Login efetuado com sucesso!')}</i>`,
                        color: "#739E73",
                        timeout: 3000
                    });
                } catch (error) {
                    $scope.pop.load = false;
                    $scope.pop.retorno = JSON.stringify(error.data, null, 2);
                }
            }
        }

        $scope.Salvar = async (f) => {
            if (f.$valid) {
                let dados = JSON.parse(JSON.stringify($scope.popup));
                delete dados.id;
                delete dados.autenticacaoTipos;

                dados.config = {};
                for (let i = 0; i < $scope.popup.config.length; ++i) {
                    let ob = $scope.popup.config[i];
                    dados.config[ob.parametro] = ob.valor;
                }

                try {
                    if ($scope.popup.id) {
                        await $http.put(`${options.api.restv4}/autenticacao_fonte/${$scope.popup.id}`, dados);
                    }
                    else {
                        await $http.post(`${options.api.restv4}/autenticacao_fonte`, dados);
                    }

                    $scope.showFontesPopup = false;
                    $.smallBox({
                        title: "SUCESSO!!",
                        content: "<i class='fa fa-check'></i> <i>Atualizado com sucesso!</i>",
                        color: "#739E73",
                        timeout: 3000
                    });
                    $scope.load();
                } catch (error) {
                    console.log(error);
                }
            }
        }

        $scope.confirma = function (row) {
            $.x5Box({
                title: "Remover <b>" + row.nome + "</b>?",
                content: "Tem certeza que quer remover " + row.nome + "? <p class='text-align-right'><a id='yes' href-void class='btn btn-danger btn-sm btncallback'>Apagar</a> <a id='no' href-void class='btn btn-primary btn-sm btncallback'>Cancelar</a></p>",
                color: "#C46A69",
                //timeout: 8000,
                icon: "fa fa-warning shake animated"
            }, function (ButtonPressed) {
                if (ButtonPressed === "Apagar") {
                    $scope.delete(row.id);
                }
            });
        };

        $scope.delete = function (id) {
            $http.delete(options.api.restv4 + "/autenticacao_fonte/" + id).
                success(function (s) {
                    $.smallBox({
                        title: "SUCESSO!!",
                        content: "<i class='fa fa-check'></i> <i>Apagado com sucesso!</i>",
                        color: "#739E73",
                        timeout: 3000
                    });

                    $scope.load();
                })
        };

        $scope.SelTipo = () => {
            if ($scope.popup.config) return;

            switch ($scope.popup.tipo) {
                case 2:
                    $scope.isNew = true;
                    $scope.popup.config = [
                        { parametro: "url", valor: "ldap://IP_ou_Nome_do_servidor:PORTA" },
                        { parametro: "bindDN", valor: "cn=admin,dc=exemplo,dc=com" },
                        { parametro: "bindCredentials", valor: "SENHA" },
                        { parametro: "searchBase", valor: "ou=DIRETORIO,dc=exemplo,dc=com" },
                        { parametro: "searchFilter", valor: "(uid={{username}})" }
                    ];
                    break;

                default:
                    break;
            }
        }
    })
});
