define([
    'angular',
    'angular-couch-potato',
    'lodash',
    'angular-ui-router',
    'angular-resource',
    'isteven-multi-select',
    'ngTagsInput',
    'bootstrap-toggle'

], function (ng, couchPotato, _) {
    'use strict';

    var module = ng.module('app.fonteautenticacao', [
        'ui.router',
        'ngResource',
        'isteven-multi-select',
        'ngTagsInput',
        'toggle-switch'
    ]);


    couchPotato.configureApp(module);

    module.config(function ($stateProvider, $couchPotatoProvider) {

        $stateProvider
            .state('app.fonteautenticacao', {
                url: '/fontes_autenticacao',
                data: {
                    title: 'Fontes de autenticação',
                    permissions: {
                        only: ['app.fonteautenticacao']
                    }
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/fontes_autenticacao/views/lista.html',
                        controller: 'FontesautenticacaoCtrl',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'util/util',
                                'modules/fontes_autenticacao/controllers/FontesautenticacaoCtrl',
                                'modules/forms/directives/input/smartTimepicker',
                                'modules/forms/directives/input/smartClockpicker'
                            ])
                        }
                    }
                }
            })
    });

    module.run(function ($couchPotato, Permission, $localStorage, ModuloPermissao) {
        module.lazy = $couchPotato;
        Permission.defineRole('app.fonteautenticacao', function () {
            if (!$localStorage.User || !ModuloPermissao.UsuarioTemModulo("app.fonteautenticacao", $localStorage.User.modulos)) {
                $localStorage.msg = {
                    tipo: "Erro",
                    txt: "Você não tem acesso ao fontes_autenticacao."
                };
                return false;
            }
            else {
                return true;
            }
        });
    });

    return module;

});
