define([
    'angular',
    'angular-couch-potato',
    'angular-ui-router',
    'angular-resource',
    'raphael',
    'jusgage'
], function (ng, couchPotato) {
    'use strict';

    var module = ng.module('app.indicadores', [
        'ui.router',
        'ngResource'
    ]);
    
    couchPotato.configureApp(module);

    module.config(function ($stateProvider, $couchPotatoProvider, wsProvider) {
        wsProvider.setUrl(options.api.ws);
        
        $stateProvider
            .state('app.indicadores', {
                abstract: true,
                data: {
                    title: 'Indicadores',
                    permissions: {
                        only: ['app.indicadores']
                    }
                }
            })
            
            .state('app.indicadores.fila', {
                url: '/indicadores/fila',
                data: {
                    title: 'Indicador de Fila'
                },
                views: {
                    "content@app": {
                        controller: 'NSfilaCtrl',
                        templateUrl: 'app/modules/indicadores/view/nsfila.html',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/indicadores/controllers/NSfilaCtrl',
                                'modules/indicadores/directives/justGage'
                            ])
                        }
                    }
                }
            })                       
    });    

    module.run(function ($couchPotato,Permission,$localStorage,ModuloPermissao) {
        module.lazy = $couchPotato;        
        Permission.defineRole('app.indicadores', function () {
            if(!$localStorage.User || !ModuloPermissao.UsuarioTemModulo("app.indicadores",$localStorage.User.modulos)){
               $localStorage.msg = {
                   tipo: "Erro",
                   txt: "Você não tem acesso aos indicadores."
               };               
               return false;
            }            
            else {                
                return true;         
            }
        });
    });

    return module;
});