define([
    'angular',
    'angular-couch-potato',
    'angular-ui-router',
    'angular-resource',
    'ngTagsInput',
    'underscore',
    'doubleScrollBars',
    'moment',
    'moment-br',
    'moment-timezone',
    'moment-duration-format'
], function (ng, couchPotato, _) {
    'use strict';

    var module = ng.module('app.jbs_discador_relatorios', [
        'ui.router',
        'ngResource',
        'ngTagsInput',
        'angularjs-dropdown-multiselect',
        'doubleScrollBars'
    ]);

    couchPotato.configureApp(module);

    module.config(function ($stateProvider, $couchPotatoProvider) {

        $stateProvider
            .state('app.jbs_discador_relatorios', {
                url: '/jbs_discador_relatorios_visao_macro',
                data: {
                    title: 'Visão macro',
                    permissions: {
                        only: ['app.jbs_discador_relatorios']
                    }
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/jbs_discador_relatorios/views/visao_macro.html',
                        controller: 'VisaoMacroCtrl',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'util/time',
                                'util/util',
                                'modules/jbs_discador_relatorios/controllers/VisaoMacroCtrl',
                                'modules/forms/directives/input/smartDatepicker',
                                'modules/forms/directives/input/smartTimepicker',
                                'modules/forms/directives/input/smartClockpicker'
                            ])
                        },
                    }
                }
            })
    });

    module.run(function ($couchPotato, Permission, $localStorage, ModuloPermissao) {
        module.lazy = $couchPotato;
        Permission.defineRole('app.jbs_discador_relatorios', function () {
            if (!$localStorage.User || !ModuloPermissao.UsuarioTemModulo("app.jbs_discador_relatorios", $localStorage.User.modulos)) {
                $localStorage.msg = {
                    tipo: "Erro",
                    txt: "Você não tem acesso a este relatório"
                };
                return false;
            }
            else {
                return true;
            }
        });
    });


    return module;

});