define(['modules/ligacoesura/module'], function (module) {
    "use strict";

    return module.registerController('ligacoesURACtrl', function ($scope, $filter, ApiService, clientSidePaginationService, exportFilesService) {
        $scope.showPopUp = false;

        $scope.searchText = '';
        $scope.id_client = options.id_client;
        $scope.data_a = options.data_a;
        $scope.data_b = options.data_b;

        // Injeta paginação
        $scope.pag = clientSidePaginationService;
        $scope.pag.dados = [];
        $scope.pag.sortBy = 'calldate';

        $scope.campos = [
            { nome: $scope.getWord("Origem"), valor: "src" },
            { nome: $scope.getWord("Menu"), valor: "menu" },
            { nome: $scope.getWord("Opção"), valor: "opcao" },
            { nome: $scope.getWord("Menu Origem"), valor: "src_menu" }
        ]

        if ($scope.id_client && $scope.id_client.enable) {
            $scope.campos.push({ nome: $scope.getWord($scope.id_client.name), valor: "id_client" },);
        }
        if ($scope.data_a && $scope.data_a.enable) {
            $scope.campos.push({ nome: $scope.getWord($scope.data_a.name), valor: "data_a" },);
        }
        if ($scope.data_b && $scope.data_b.enable) {
            $scope.campos.push({ nome: $scope.getWord($scope.data_b.name), valor: "data_b" },);
        }

        $scope.load = function () {
            $scope.filtro = {};
            // $scope.searchCampo = $scope.campos[0];
            // $scope.searchCampoValor = [];
            $scope.searchCampoOrigem = [];
            $scope.searchCampoMenu = [];
            $scope.searchCampoOpcao = [];
            $scope.searchCampoMenuOrigem = [];
            $scope.searchCampoCliente = [];
            $scope.searchCampoSucesso = [];
            $scope.searchCampoMensagem = [];
            $scope.filtro.data_ini = new Date();
            $scope.filtro.data_fim = new Date();
            $scope.ToList();
        };

        $scope.filter = async function () {
            let filteredRT = angular.copy($scope.reminderTypes);

            if ($scope.searchCampoOrigem.length > 0) {
                const tags = $scope.searchCampoOrigem.map(tag => {
                    return tag.text.toLowerCase();
                })

                filteredRT = filteredRT.filter(function (obj) {
                    return tags.find(tag => {
                        return obj.src && obj.src.toString().toLowerCase().includes(tag);
                    })
                });
            }

            if ($scope.searchCampoMenu.length > 0) {
                const tags = $scope.searchCampoMenu.map(tag => {
                    return tag.text.toLowerCase();
                })

                filteredRT = filteredRT.filter(function (obj) {
                    return tags.find(tag => {
                        return obj.menu && obj.menu.toString().toLowerCase().includes(tag);
                    })
                });
            }

            if ($scope.searchCampoOpcao.length > 0) {
                const tags = $scope.searchCampoOpcao.map(tag => {
                    return tag.text.toLowerCase();
                })

                filteredRT = filteredRT.filter(function (obj) {
                    return tags.find(tag => {
                        return obj.opcao && obj.opcao.toString().toLowerCase().includes(tag);
                    })
                });
            }

            if ($scope.searchCampoMenuOrigem.length > 0) {
                const tags = $scope.searchCampoMenuOrigem.map(tag => {
                    return tag.text.toLowerCase();
                })

                filteredRT = filteredRT.filter(function (obj) {
                    return tags.find(tag => {
                        return obj.src_menu && obj.src_menu.toString().toLowerCase().includes(tag);
                    })
                });
            }

            if ($scope.searchCampoCliente.length > 0) {
                const tags = $scope.searchCampoCliente.map(tag => {
                    return tag.text.toLowerCase();
                })

                filteredRT = filteredRT.filter(function (obj) {
                    return tags.find(tag => {
                        return obj.id_client && obj.id_client.toString().toLowerCase().includes(tag);
                    })
                });
            }

            if ($scope.searchCampoSucesso.length > 0) {
                const tags = $scope.searchCampoSucesso.map(tag => {
                    return tag.text.toLowerCase();
                })

                filteredRT = filteredRT.filter(function (obj) {
                    return tags.find(tag => {
                        return obj.data_a && obj.data_a.toString().toLowerCase().includes(tag);
                    })
                });
            }

            if ($scope.searchCampoMensagem.length > 0) {
                const tags = $scope.searchCampoMensagem.map(tag => {
                    return tag.text.toLowerCase();
                })

                filteredRT = filteredRT.filter(function (obj) {
                    return tags.find(tag => {
                        return obj.data_b && obj.data_b.toString().toLowerCase().includes(tag);
                    })
                });
            }

            if ($scope.searchText.length > 0) {
                filteredRT = filteredRT.filter(function (obj) {
                    return Object.values(obj).find(v => {
                        if (v) {
                            return v.toString().toLowerCase().includes($scope.searchText.toLowerCase());
                        }
                    })
                });
            }

            // Pagina os dados filtrados
            $scope.pag.dados = filteredRT;
            // Ordena
            $scope.pag.order();
        };


        $scope.ToList = function () {
            $scope.carregando_export = false;
            $scope.loading = true;
            $scope.getdata = true;

            const filtros = angular.copy($scope.filtro);
            filtros.data_ini = $filter('date')(filtros.data_ini, 'yyyy-MM-dd');
            filtros.data_fim = $filter('date')(filtros.data_fim, 'yyyy-MM-dd');

            ApiService.get(options.api.restv4 + "/ura_fluxo", filtros).
                success(function (data) {
                    $scope.loading = false;
                    $scope.reminderTypes = data;
                    $scope.filter();
                })
                .error(er => {
                    $scope.loading = false;
                    console.log(`Deu erro no get`);
                    console.log(er);
                })
        };

        $scope.setNeedget = () => {
            $scope.pag.dados = [];
            $scope.getdata = false;
        };

        $scope.ToCSV = async function () {
            $scope.carregando_export = true;
            let arr = [];

            // Formata cabeçalho
            let cab = [
                $scope.getWord('Data'),
                $scope.getWord('Origem'),
                $scope.getWord('Menu'),
                $scope.getWord('Opção'),
                $scope.getWord('Menu de Origem')
            ];
            if ($scope.id_client.enable) cab.push($scope.id_client.name);
            if ($scope.data_a.enable) cab.push($scope.data_a.name);
            if ($scope.data_b.enable) cab.push($scope.data_b.name);

            arr.push(cab);

            // Formata dados
            $scope.pag.dados.forEach((e) => {
                var linha = [];
                linha.push($filter('date')(e.calldate, 'dd/MM/yyyy HH:mm:ss'));
                linha.push(e.src);
                linha.push(e.menu);
                linha.push(e.opcao);
                linha.push(e.src_menu);
                if ($scope.id_client.enable) linha.push(e.id_client || e.identclient || "");
                if ($scope.data_a.enable) linha.push(e.data_a);
                if ($scope.data_b.enable) linha.push(e.data_b);

                arr.push(linha);
            });

            exportFilesService.gerarCSV(arr, "Ligacoes de URA.csv").then(
                dados => {
                    console.log(`Sucesso na geraCSV, ${dados}`);
                    $scope.carregando_export = false;
                },
                erro => {
                    console.log(`Erro na geraCSV ${erro}`)
                }
            )
        };

        $scope.ToPDF = async function () {
            $scope.carregando_export = true;

            const filtros = angular.copy($scope.filtro);
            if ($scope.searchText) filtros.pesquisa = $scope.searchText;
            if ($scope.searchCampoValor) filtros.searchCampoValor = $scope.searchCampoValor;
            if ($scope.searchCampo) filtros.searchCampo = $scope.searchCampo;


            var linhas = [];
            //Composição do header
            let cabecalho = [
                $scope.getWord('Data'),
                $scope.getWord('Origem'),
                $scope.getWord('Menu'),
                $scope.getWord('Opção'),
                $scope.getWord('Menu de Origem')
            ];
            if ($scope.id_client.enable) cabecalho.push($scope.id_client.name);
            if ($scope.data_a.enable) cabecalho.push($scope.data_a.name);
            if ($scope.data_b.enable) cabecalho.push($scope.data_b.name);
            if (options.multserver) cabecalho.unshift('Servidor');

            //Dados
            $scope.pag.dados.forEach((e) => {
                var linha = [];
                linha.push($filter('date')(e.calldate, 'dd/MM/yyyy HH:mm:ss'));
                linha.push(e.src);
                linha.push(e.menu);
                linha.push(e.opcao);
                linha.push(e.src_menu);
                if ($scope.id_client.enable) linha.push(e.id_client || "");
                if ($scope.data_a.enable) linha.push(e.data_a || "");
                if ($scope.data_b.enable) linha.push(e.data_b || "");

                linhas.push(linha);
            });

            //Totalizações
            linhas.push(['Total', $scope.pag.dados.length]);

            // Titulo
            const titulo = { texto: $scope.getWord('Fluxo de URA'), x: 40, y: 60 };

            // Subtitulo
            const subtitulo = [
                { texto: `${$scope.getWord('De')} ${$filter('data')(filtros.data_ini)} ${$scope.getWord('até')} ${$filter('data')(filtros.data_fim)}`, x: 40, y: 80 }
            ];

            if (filtros.hora_ini && filtros.hora_fim) {
                subtitulo.push({ texto: `${$scope.getWord('entre')} ${filtros.hora_ini} ${$scope.getWord('e')} ${filtros.hora_fim}`, x: 150, y: 80 });
            } else if (filtros.hora_ini) {
                subtitulo.push({ texto: `${$scope.getWord('a partir das')} ${filtros.hora_ini}`, x: 150, y: 80 });
            } else if (filtros.hora_fim) {
                subtitulo.push({ texto: `${$scope.getWord('até as')} ${filtros.hora_fim}`, x: 150, y: 80 });
            }

            if (filtros.pesquisa) {
                subtitulo.push({ texto: $scope.getWord('Pesquisa global') + ` ${$scope.getWord('contendo')} ${filtros.pesquisa}`, x: 40, y: 100 });
            }
            if (filtros.searchCampoValor && filtros.searchCampoValor.length > 0) {
                const tags = filtros.searchCampoValor.map(tag => {
                    return tag.text;
                })
                subtitulo.push({ texto: $scope.getWord('Filtro por') + ` ${$scope.searchCampo.nome} ${$scope.getWord('contendo')} ${tags}`, x: 255, y: 100 });
            }

            const ret = await exportFilesService.gerarPDF(cabecalho, linhas, titulo, subtitulo, "Ligacoes de URA.pdf");

            console.log(ret);
            $scope.carregando_export = false;
        };

    });
});
