define([
    'angular',
    'angular-couch-potato',
    'lodash',
    'angular-ui-router',
    'angular-resource',
    'ngTagsInput',
    'underscore',
    'jspdf',
    'autotable'
], function (ng, couchPotato, _) {
    'use strict';

    var module = ng.module('app.ligacoesura', [
        'ui.router',
        'ngResource',
        'ngTagsInput'
    ]);


    couchPotato.configureApp(module);

    module.config(function (tagsInputConfigProvider) {
        tagsInputConfigProvider
            .setActiveInterpolation('tagsInput', { placeholder: true });
    });

    module.config(function ($stateProvider, $couchPotatoProvider) {

        $stateProvider
            .state('app.ligacoesura', {
                url: '/ligacoesura',
                data: {
                    title: 'Ligações da URA',
                    permissions: {
                        only: ['app.ligacoesura']
                    }
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/ligacoesura/views/lista.html',
                        controller: 'ligacoesURACtrl',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/ligacoesura/controllers/ligacoesURACtrl',
                                'modules/ligacoesura/directives/ligacoesUraFormValidate',
                                'modules/ui/directives/smartProgressbar'
                            ])
                        },
                    }
                }
            })
    });

    module.run(function ($couchPotato, Permission, $localStorage, ModuloPermissao) {
        module.lazy = $couchPotato;
        Permission.defineRole('app.ligacoesura', function () {
            if (!$localStorage.User || !ModuloPermissao.UsuarioTemModulo("app.ligacoesura", $localStorage.User.modulos)) {
                $localStorage.msg = {
                    tipo: "Erro",
                    txt: "Você não tem acesso ao relatório de ligações da URA."
                };
                return false;
            }
            else {
                return true;
            }
        });
    });


    return module;

});
