define(['modules/listas/module'], function(module){
    "use strict";

    return module.registerController('UploadCtrl', function($scope, Upload, $timeout, $stateParams, $rootScope){        
        $scope.row = {};
        $scope.campos_disable = false;
        $scope.order = 'nome';
        $scope.order_sentido = 'ASC';
        
        $scope.lista = "";       
        
        if($stateParams.lista){
            $scope.row.id_lista = $stateParams.lista;
            //console.log($scope.row.id_lista);
        }
        
        $scope.uploadFiles = function(files) {
            $scope.files = files;
            angular.forEach(files, function(file) {
                if (file && !file.$error) {
                            file.upload = Upload.upload({
                      url: options.api.rest+"/lista_upload/"+$scope.row.id_lista,
                      file: file
                    });

                    file.upload.then(function (response) {
                      $timeout(function () {
                        file.result = response.data;
                      });
                    }, function (response) {
                      if (response.status > 0){
                        $scope.errorMsg = response.status + ': ' + response.data;
                      }
                      else {
                          console.log('OK: '+response.data);
                      }
                    });

                    file.upload.progress(function (evt) {
                      file.progress = Math.min(100, parseInt(100.0 * 
                                               evt.loaded / evt.total));
                    });
                    }   
            });
        };
        
    });
});