define(['modules/listas/module', 'jquery-maskedinput', 'jquery-validation'], function (module) {

    'use strict';

    return module.registerDirective('contatoFormValidate', function () {
        return {
            restrict: 'E',
            replace: true,
            templateUrl: 'app/modules/listas/views/contatos.tpl.html',
            scope: true,
            link: function (scope, form) {
               var validateOptions = {
                    errorElement: 'em',
                    errorClass: 'invalid',
                    highlight: function(element, errorClass, validClass) {
                        $(element).addClass(errorClass).removeClass(validClass);
                        $(element).parent().addClass('state-error').removeClass('state-success');
                    },
                    unhighlight: function(element, errorClass, validClass) {
                        $(element).removeClass(errorClass).addClass(validClass);
                        $(element).parent().removeClass('state-error').addClass('state-success');
                    },
                    errorPlacement : function(error, element) {
                        error.insertAfter(element.parent());
                    }
                };
                
               form.validate(angular.extend({
                    // Rules for form validation
                    rules : {
                        numero : {
                            required : true,
                            digits : true
                        },
                        nome : {
                            required : true
                        }
                    },
                    
                    submitHandler: function() { scope.$parent.Salvar() },

                    // Messages for form validation
                    messages : {
                        numero : {
                            required : 'O número é obrigatorio.',
                            digits : 'Só pode ser númerico.'
                        },
                        nome : {
                            required : 'O nome é obrigatoria.'
                        }
                    }
                }, validateOptions));

            }
        }
    });
});
