define([
    'angular',
    'angular-couch-potato',
    'lodash',
    'angular-ui-router',
    'angular-resource',
    'raphael',
    'jusgage',
    'highcharts',
    'highcharts-export',
    'angular-highcharts'

], function (ng, couchPotato, _) {
    'use strict';

    var module = ng.module('app.login', [
        'ui.router',
        'ngResource',
        'easypiechart',
        'highcharts-ng'
    ]);


    couchPotato.configureApp(module);

    module.config(function ($stateProvider, $couchPotatoProvider) {

        $stateProvider
            .state('login', {
                url: '/login',
                controller: 'LoginCtrl',
                views: {
                    root: {
                        templateUrl: 'app/modules/login/views/login.html'
                    }
                },
                data: {
                    title: 'Login',
                    htmlId: 'extr-page'
                },
                resolve: {
                    deps: $couchPotatoProvider.resolveDependencies([
                        'modules/login/controllers/LoginCtrl',
                        'modules/forms/directives/validate/smartValidateForm',
                        'util/util'
                    ])
                }
            })
            .state('logoff', {
                url: '/logoff',
                controller: 'LoginCtrl',
                views: {
                    root: {
                        templateUrl: 'app/modules/login/views/login.html'
                    }
                },
                data: {
                    title: 'Login',
                    permissions: {
                        except: ['anonimo']
                    }
                },
                resolve: {
                    deps: $couchPotatoProvider.resolveDependencies([
                        'modules/login/controllers/LoginCtrl',
                        'modules/forms/directives/validate/smartValidateForm'
                    ])
                }
            })
            .state('app.home', {
                url: '/home',  
                controller: 'LoginCtrl',
                data: {
                    title: 'Home',
                    permissions: {
                        except: ['anonimo']
                    }
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/login/views/home.html',
                        controller: 'LoginCtrl',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/login/controllers/LoginCtrl',
                                'modules/x5graficos/directives/justGage'
                            ])
                        },                        
                    }
                }                
            })
    });

    module.run(function ($couchPotato,Permission,$localStorage,$rootScope) {
        module.lazy = $couchPotato;
        Permission.defineRole('anonimo', function () {
            if(!$localStorage.User){
               $localStorage.msg = {
                   tipo: "Erro",
                   txt: $rootScope.getWord("Você precisa estar logado no sistema.")
               };               
               return true;
            }            
            else {                
                return false;         
            }
        });
    });

    return module;

});