define(['modules/membros/module'], function (module) {
    "use strict";

    return module.registerController('MembrosCtrl', function ($scope, $http, $stateParams, $rootScope, paginationService) {
        $scope.row = {};
        $scope.campos_disable = false;
        $scope.senhaantiga = "";
        $scope.order = 'membername';
        $scope.order_sentido = 'ASC';
        $scope.Pesquisa = '';
        $scope.sortDescending = false;

        $scope.getCurPage = () => {
            return paginationService.getCurrentPage('pag');
        }

        $scope.getTotalPages = () => {
            return Math.ceil(paginationService.getCollectionLength('pag') / paginationService.getItemsPerPage('pag'))
        }

        $scope.getTotalItens = () => {
            return paginationService.getCollectionLength('pag');
        }

        $scope.filter = function () {
            var results = $scope.rows;
            results.length = 0;
            var searchText = $scope.Pesquisa;
            var reminderTypes = $scope.reminderTypes;

            for (var i = 0; i < reminderTypes.length; ++i) {
                if (searchText.length > 0) {
                    if (reminderTypes[i].membername && reminderTypes[i].id != 9999999 && reminderTypes[i].membername.toLowerCase().includes(searchText.toLowerCase())
                        || (reminderTypes[i].interface && reminderTypes[i].interface.includes(searchText))
                        || (reminderTypes[i].queue_name && reminderTypes[i].queue_name.toLowerCase().includes(searchText.toLowerCase()))) {
                        results.push(reminderTypes[i]);
                    }
                } else {
                    if (reminderTypes[i].id != 9999999) {
                        results.push(reminderTypes[i]);
                    }
                }
            }
            results.sort(function (a, b) {
                var sortBy = $scope.sortBy;
                if (a[sortBy] < b[sortBy]) {
                    return $scope.sortDescending ? 1 : -1;
                }
                if (a[sortBy] > b[sortBy]) {
                    return $scope.sortDescending ? -1 : 1;
                }
                return 0;
            });
        };

        $scope.load = function () {
            $scope.carregando = true;
            $http.get(options.api.restv3 + "/agente_estatico?max=-1").
                success(function (data) {
                    $scope.reminderTypes = data.dados;
                    $scope.rows = angular.copy($scope.reminderTypes);
                    $scope.table = data;
                    $rootScope.rows = data.dados;
                    $scope.filter();
                    $scope.carregando = false;
                });
        };

        $scope.init = function () {
            $scope.load();
        };

        $scope.setOrder = function (keyname) {
            $scope.sortBy = keyname;
            $scope.sortDescending = !$scope.sortDescending;
            $scope.filter();
        };

        if ($rootScope.$state.current.url.indexOf('ver') > 0) {
            $scope.campos_disable = true;
        }

        if ($rootScope.$state.current.url.indexOf('novo') > 0) {
            $http.get(options.api.restv2 + "/filas?max=-1").
                success(function (data) {
                    $scope.filas = data.dados;
                });
        }

        $scope.CarregarItem = function (id) {
            angular.forEach($rootScope.rows, function (r) {
                if (r.uniqueid == id) {
                    $scope.row = angular.copy(r);
                    return;
                }
            });
        };

        if ($stateParams.id) {
            $scope.CarregarItem($stateParams.id);

            $http.get(options.api.restv2 + "/filas?max=-1").
                success(function (data) {
                    $scope.filas = data.dados;

                    if ($scope.row.queue_name) {
                        angular.forEach($scope.filas, function (f) {
                            if (f.name == $scope.row.queue_name) {
                                $scope.row.queue_name = f;
                                return;
                            }
                        });
                    }
                });
        }

        $scope.Editar = function () {
            $scope.campos_disable = false;
        };

        $scope.Cancelar_editar = function () {
            $scope.CarregarItem($stateParams.id);
            $scope.campos_disable = true;
        };

        $scope.Salvar = function () {
            let editando = {
                membername: $scope.row.membername,
                interface: $scope.row.interface,
                queue_name: $scope.row.queue_name.name
            };

            if (!$scope.row.uniqueid) {
                $http.post(options.api.restv3 + "/agente_estatico", editando).
                    success(function (data) {
                        $.smallBox({
                            title: "SUCESSO!!",
                            content: "<i class='fa fa-check'></i> <i>Salvo com sucesso!</i>",
                            color: "#739E73",
                            timeout: 6000
                        });
                        $rootScope.$state.transitionTo('app.membros');
                    })
            } else {
                $http.put(options.api.restv3 + `/agente_estatico/${$scope.row.uniqueid}`, editando).
                    success(function (data) {
                        $.smallBox({
                            title: "SUCESSO!!",
                            content: "<i class='fa fa-check'></i> <i>Salvo com sucesso!</i>",
                            color: "#739E73",
                            timeout: 6000
                        });
                        $rootScope.$state.transitionTo('app.membros');
                    })
            }
        };

        $scope.Voltar = function () {
            $rootScope.$state.transitionTo('app.membros');
        };

        $scope.confirma = function (row) {
            $.x5Box({
                title: "Remover <b>" + row.membername + "</b>?",
                content: "Tem certeza que quer remover " + row.membername + "? <p class='text-align-right'><a id='yes' href-void class='btn btn-danger btn-sm btncallback'>Apagar</a> <a id='no' href-void class='btn btn-primary btn-sm btncallback'>Cancelar</a></p>",
                color: "#C46A69",
                //timeout: 8000,
                icon: "fa fa-warning shake animated"
            }, function (ButtonPressed) {
                if (ButtonPressed === "Apagar") {
                    $scope.delete(row.uniqueid);
                }
            });
        };

        $scope.delete = function (id) {
            $http.delete(options.api.restv3 + "/agente_estatico/" + id).
                success(function (s) {
                    $.smallBox({
                        title: "SUCESSO!!",
                        content: "<i class='fa fa-check'></i> <i>Membro apagado com sucesso!</i>",
                        color: "#739E73",
                        timeout: 6000
                    });

                    $scope.load();
                })
        };

        $scope.getClass = function (coluna) {
            if ($scope.order === coluna) {
                return $scope.order_sentido === 'ASC' ? 'sorting_asc' : 'sorting_desc';
            }
            else {
                return 'sorting';
            }
        };
    });
});