define(['modules/painelsupervisor/module'], function (module) {
    "use strict";

    module.registerController('OnlineCtrlNew', function ($scope, $http, $Store, $interval, $filter, $localStorage, desktopNotification, $Xcmobx) {
        console.log('--- Online new ---')
        console.log($Xcmobx)
        $scope.Xcmobx = $Xcmobx

        $scope.Tick = () => {
            console.log('--- Tick ---')
            $Xcmobx.addAgente({fila:'Zulu'})
            console.log($Xcmobx)
        }

        requisitarStatusDasFilasInicial();
        $scope.notificar = {};
        if ($localStorage.OnlineNotificacoes) {
            $scope.notificar = $localStorage.OnlineNotificacoes;
            //console.log($scope.notificar)
        }

        $scope.nao_exibe_locais = options.online_nao_exibe_internas;

        $scope.filtrosdev = false;

        $scope.filas = [];
        $scope.agentes = [];
        $scope.agentes_list = [];
        $scope.timers = [];
        $scope.filtro = {
            agentes: [],
            filas: []
        };
        $scope.janela = [];
        $scope.statusConexao = "conectando";
        $scope.carregando = true;

        $scope.opcoes_naoatendidas = { barColor: '#ff021a', scaleColor: false, trackColor: '#e5e5e5', lineWidth: 10, lineCap: 'circle', size: 125 };
        $scope.opcoes_atendidas = { barColor: '#71843f', scaleColor: false, trackColor: '#e5e5e5', lineWidth: 10, lineCap: 'circle', size: 125 };
        $scope.opcoes_efetuadas = { barColor: '#57889c', scaleColor: false, trackColor: '#e5e5e5', lineWidth: 10, lineCap: 'circle', size: 125 };
        $scope.opcoes_realizados = { barColor: '#92a2a8', scaleColor: false, trackColor: '#e5e5e5', lineWidth: 10, lineCap: 'circle', size: 125 };

        $scope.UserFilas = JSON.parse(JSON.stringify($localStorage.User.filas));

        $scope.NotifyisSupported = desktopNotification.isSupported();
        $scope.Notifypermission = desktopNotification.currentPermission();


        $scope.PediPermicao = function () {
            desktopNotification.requestPermission().then(function (permission) {
                $scope.Notifypermission = permission;
                alert($scope.getWord('Permissão concedida.'));
            }, function (permission) {
                $scope.Notifypermission = permission;

                if ($scope.Notifypermission === 'denied') {
                    alert($scope.getWord('Você não autorizou o uso de notificações de área de trabalho. Se tiver utilizando Google Chrome clique no ícone de informações da página que fica fica a esquerda do endereço desta página e autorize as notificações.'));
                } else {
                    alert($scope.getWord('Permissão negada.'));
                }
            });
        };

        $scope.ChangeNotify = () => {
            $scope.juca = 'Alterado'
            $localStorage.OnlineNotificacoes = $scope.notificar;

            if ($scope.Notifypermission != 'granted') {
                $scope.PediPermicao();
            }
            //console.log(`É suportado? ${$scope.NotifyisSupported}`);
            if (!$scope.NotifyisSupported) {
                alert($scope.getWord('Seu navegador não suporta notificações, use o Google Chrome ou um navegador que suporte.'))
            }
            //console.log(`Como está? ${$scope.NotifyisSupported}`);
        }

        function notifica (titulo, texto) {
            $scope.notif = desktopNotification.show(titulo, {
                icon: 'styles/img/logo-o.png',
                body: texto,
                autoClose: false,
                vibrate: true,
                onClick: function (event) {
                    window.focus();
                    $scope.notif.close();
                }
            });
        }

        function groupBy (ar, col) {
            var r = [], o = {}, array = JSON.parse(JSON.stringify(ar));
            array.forEach(function (a) {
                if (!o[a[col]]) {
                    //o[a[col]] = {};
                    //o[a[col]][col] = a[col];
                    o[a[col]] = a;
                    o[a[col]]['filas'] = [];
                    r.push(o[a[col]]);
                }
                o[a[col]]['filas'].push(a['fila']);
            });
            return r;
        }

        $scope.removerDuplicatas = function (filas) {
            let after = [...new Set(filas)];
            ////console.log(`Before: `, filas, `After: `, after);
            return after.join(", ");
        };

        $scope.agentes_list_filter = function () {
            var tmp = $scope.agentes_list.filter(agente => {
                if (!$scope.agenteFilter.length) return agente;
                else {
                    if ($scope.agenteFilter.includes(agente.nome)) {
                        return agente;
                    }
                }
            });
            if ($scope.agenteFilter.length) {
                tmp.sort(function (a, b) {
                    return $scope.agentes_list.indexOf(a.nome) - $scope.agentes_list.indexOf(b.nome);
                });
                return tmp;
            } else {
                return tmp;
            }
        }


        function getAgenteStatusReal (agente) {
            // Retorna: 0 - Invalido, 1 - Online, 2 - Ocupado, 3 - Tocando e 10 - Pausa
            switch (agente.status) {
                case 1:
                    return 1;
                case 2:
                    return 2;
                case 3:
                    return 2;
                case 6:
                    return 3;
                case 7:
                    return 3;
                case 8:
                    return 10;
                case 10: {
                    if (agente.ligacoes_ativas && agente.ligacoes_ativas.length > 0) {
                        return 2;
                    } else {
                        return 10;
                    }
                }
                default:
                    return 0;
            }
        }

        $scope.getAgenteStatus = function (agente) {
            // Verifica se o agente estava com uma ligação
            if (agente.status === 10 && agente.ligacoes_ativas && agente.ligacoes_ativas.length > 0) {
                return "Ocupado";
            } else {
                // Busca o motivo da pausa
                let motivo = agente.motivo || $scope.getWord("Pausa");
                return agente.pausa ? motivo : $scope.getWord(agente.StatusNome);
            }
        };

        $scope.getAgenteStatusLb = function (agente) {
            switch (agente.status) {
                case 1:
                    return 'label-success';
                case 2:
                    return 'label-danger';
                case 3:
                    return 'label-danger';
                case 6: // Ringing
                    return 'label-info';
                case 7:
                    return 'label-danger';
                case 8:
                    return 'label-warning';

                // Pausa -- Nao existe no asterisk, criado para o paused = 1
                case 10: {
                    // Verifica se o agente tem ligações em curso
                    if (agente.ligacoes_ativas && agente.ligacoes_ativas.length > 0) {
                        // Se está em pausa, mas possui ligações, o cliente sip o colocou em AutoPausa para atendimento e classificação
                        // Mas devemos apresenta-lo como ocupado
                        return 'label-danger';
                    } else {
                        return 'label-warning';
                    }
                }

                default:
                    return 'label-default';
            }
        };

        function groupAgentes () {
            var agentes = [];
            for (var i = 0; i < $scope.filas.length; ++i) {
                for (var j = 0; j < $scope.filas[i].agentes.length; ++j) {
                    agentes.push($scope.filas[i].agentes[j]);
                }
            }
            $scope.agentes = groupBy(agentes, 'ramal');
        }

        $scope.getAgentesGroup2 = function () {
            var agentes = [];
            for (var f = 0; f < $scope.filas.length; f++) {
                for (var a = 0; a < $scope.filas[f].agentes.length; a++) {
                    var agente = $scope.filas[f].agentes[a];
                    var tem = false;
                    for (var n = 0; n < agentes.length; n++) {
                        if (agentes[n].nome == agente.nome) {
                            tem = true;
                            if (agente.filas && agente.filas.length > 0) {
                                var tf = false;
                                for (var af = 0; af < agentes.filas.length; af++) {
                                    if (agentes.filas[af].nome = $scope.filas[f].nome) {
                                        tf = true;
                                    }
                                }
                                if (!tf) {
                                    agentes.filas.push($scope.filas[f].nome);
                                }
                            }
                        }
                    }
                }
            }
        };

        $scope.filterSave = () => {
            $localStorage.Onlinefilas = $scope.filtro.filas.map(f => f.text);
        }

        $scope.filterNg = function (item) {
            if ($scope.filtro.filas && $scope.filtro.filas.length > 0) {
                let ar = $scope.filtro.filas.map(item => item.text);
                return ar.includes(item.nome);
            }
            else {
                return item;
            }
        };

        $scope.filterAgente = function () {
            if ($scope.filtro.agentes.length > 0) {
                var temp = [];
                angular.forEach($scope.filtro.agentes, function (ag) {
                    $scope.agentes.filter(function (a) {
                        if (a.nome.indexOf(ag.nome) !== -1) {
                            temp.push(a);
                        }
                    });
                });
                $scope.agentes = temp;
            }
        };

        $scope.filterAgenteA = function (ag) {
            if ($scope.filtro.filas.length > 0) {
                for (var i = 0; i < $scope.filtro.filas.length; i++) {
                    ////console.log($scope.filtro.filas[i]);
                    return ag.nome.indexOf($scope.filtro.filas[i]) > -1;
                }
            }
            else {
                return ag;
            }
        };

        /*
        Função que processa o Clique no painel do agente para iniciar ou parar o timer do status.
        Inicia o timer de status quando o painel for aberto e para o timer quando painel for fechado.
        }
        */
        $scope.StatusTimer = function (agente, div) {
            let expandido = $(div).attr('aria-expanded') == "true";

            // //console.log(`StatusTimer -> ${agente.nome} -> ${expandido ? 'fechando' : 'abrindo'}`);

            let index = $scope.timers.findIndex(x => x.div === div);
            if (index !== -1) {
                $interval.cancel($scope.timers[index].interval);
                $scope.timers.splice(index, 1);
            }

            // Se true tava aberta cacela o relogio
            if (!expandido) {
                const moment = require('moment');

                let timer = { agente, div };

                timer.date = moment(agente.StatusDate)
                timer.segundos = parseInt(moment.duration(moment().diff(timer.date)).as("seconds"));

                timer.interval = $interval(function () {
                    timer.segundos++;
                }, 1000);

                $scope.timers.push(timer);
            }

            // Código legado
            /* if ($(div).attr('aria-expanded') == "true") {
                // Cancel
                if (agente.interval) {
                    //console.log(`Agente: ${agente.nome} timer cancelado!`);
                    $interval.cancel(agente.interval);
                    delete (agente.interval);
                }
            }
            else {
                if (!agente.interval) {
                    if (!agente.LocalDate) {
                        //console.log(`Agente: ${agente.nome} sem LocalDate, criando...`);
                        var statusms = new Date().getTime() - agente.StatusTimeMs;
                        agente.LocalDate = new Date(statusms);
                    }

                    var moment = require('moment');
                    var d1 = moment(agente.LocalDate);
                    var d2 = moment();
                    var duracao = moment.duration(d2.diff(d1));
                    agente.time = parseInt(duracao.as('seconds'));

                    agente.interval = $interval(function () {
                        ////console.log(`StatusTimer ${agente.nome}`);
                        agente.time++;
                    }, 1000);
                }
            } */
        };

        $scope.getTimerSeconds = function (agente, div) {
            let timer = $scope.timers.find(x => x.agente.nome === agente.nome);//x.div === div);
            return timer ? timer.segundos : 0;
        };

        $scope.TempoDecorrido = function (datast) {
            if (typeof v1 === undefined || typeof v2 === undefined) return 0;
            var moment = require('moment');
            var d1 = moment(datast);
            var d2 = moment();

            var duracao = moment.duration(d2.diff(d1));
            return duracao.get("hours");
            //var espera = espera.get("hours").toString().padStart(2, '0') +":"+ espera.get("minutes").toString().padStart(2, '0') +":"+ espera.get("seconds").toString().padStart(2, '0');
        };

        function padTime (time) {
            return (time < 10 ? "0" : "") + time;
        }

        //let statusms = new Date().getTime() - agente.StatusTimeMs;
        //newagente.MinhaHora = new Date(statusms);

        $scope.Relogio2 = function (StatusTimeMs) {
            let statusms = new Date().getTime() - StatusTimeMs;
            let MinhaHora = new Date(statusms);
            var currentTime = new Date(),
                timeElapsed = new Date(currentTime - MinhaHora),
                hour = timeElapsed.getUTCHours(),
                min = timeElapsed.getUTCMinutes(),
                sec = timeElapsed.getUTCSeconds();

            return padTime(hour) + ":" + padTime(min) + ":" + padTime(sec);
        }

        $scope.Relogio = function (datainicial) {
            var currentTime = new Date(),
                timeElapsed = new Date(currentTime - datainicial),
                hour = timeElapsed.getUTCHours(),
                min = timeElapsed.getUTCMinutes(),
                sec = timeElapsed.getUTCSeconds();

            return padTime(hour) + ":" + padTime(min) + ":" + padTime(sec);
        }

        $scope.TimeAgo = function (ini) {
            var moment = require('moment');
            // //console.log(ini + " -> " + moment(ini).locale('pt-br').fromNow())
            return moment(ini).locale('pt-br').fromNow();
        };

        $scope.getPercentual = function (v1, v2) {
            if (typeof v1 === undefined || typeof v2 === undefined) return 0;
            v1 = parseInt(v1);
            v2 = parseInt(v2);
            if (v1 === 0) return 0;
            if (v2 === 0) return 100;
            return Math.round((v1 / v2) * 100);
        };

        $scope.getSoma = function (v1, v2) {
            if (typeof v1 === undefined || typeof v2 === undefined) return 0;
            return parseInt(v1) + parseInt(v2);
        };

        $scope.filterFilas = function (query) {
            return $localStorage.User.filas.filter(function (f) {
                return f.toLowerCase().indexOf(query.toLowerCase()) != -1;
            });
        };

        $scope.getNome = function (nome) {
            return nome;
        };

        function AgenteListPopulate (filas) {
            $scope.agentes_list = [];
            for (let fila of filas) {
                // Verifica se o usuário pode ver a fila
                if ($scope.UserFilas.includes(fila.nome)) {
                    for (let agente of fila.agentes) {
                        ////console.log(agente);
                        let agentfind = $scope.agentes_list.find(ag => ag.nome === agente.nome);
                        if (agentfind) {
                            ////console.log(`Agente_list ja tem o agente: ${agente.nome}`);
                            if (!agentfind.filas.some(f => f.nome === fila.nome)) {
                                ////console.log(`Adicionando a fila ${fila.nome} na lista do agente ${agente.nome}`);
                                agentfind.filas.push(fila.nome);
                            }
                        }
                        else {
                            let newagente = Object.assign({}, agente);
                            newagente.filas = [fila.nome];
                            let statusms = new Date().getTime() - agente.StatusTimeMs;
                            newagente.MinhaHora = new Date(statusms);
                            $scope.agentes_list.push(newagente);
                        }
                    }
                }
            }
        }

        function requisitarStatusDasFilasInicial () {

            // Manda a requisição inicial para o Server, pedindo as filas
            //console.log({ metodo: "getFilas", filas: $localStorage.User.filas });
            $Store.emit('request', { metodo: "getFilas", filas: $localStorage.User.filas }, (retorno) => {
                ////console.log(retorno.data);
                //$scope.filas = retorno.data;
                //$scope.agentes = [];

                AgenteListPopulate(retorno.data);

                $scope.filas = retorno.data.map(f => {
                    // Se for uma fila whatsapp, email ou webchat, mapeia a propriedade "atendimentosAguardando" para "ligacoes"
                    if (f.atendimentosAguardando && f.atendimentosAguardando.length > 0) {
                        f.ligacoes = f.atendimentosAguardando.map(ob => ({
                            origem: ob.fromID.split('@')[0],
                            origen_nome: ob.fromName,
                            inicio: ob.dataIni,
                            posicao: ob.posicao
                        }));
                    }
                    return f;
                })

                $scope.socketReconectando = false;
                $scope.socketConectando = false;
            });
        }

        // $Store.on('QueueCallerJoin', (ev) => {
        //     //console.log('Ligação in no Online');
        //     //console.log(ev);
        // });

        function onDisconect (err) {
            console.log(`[onDisconect] `, err)

            $scope.filas = [];
            $scope.statusConexao = "desconectado";
            $Store.isConnect = false;
        }

        function onReconect (err) {
            console.log(`[onReconect] `, err)
            //$scope.filas = [];
            $Store.isConnect = false;
            $scope.statusConexao = "reconectando";
        }

        function onConect () {
            console.log(`[onConect]`)
            $Store.isConnect = true;
            requisitarStatusDasFilasInicial();
        }

        $Store.on('disconnect', onDisconect);

        $Store.on('connect_failed', onDisconect);

        $Store.on('connect_error', onDisconect);

        $Store.on("reconnect_attempt", onReconect);


        $Store.on('message', processaEventoRecebido);

        $Store.on('connect', onConect);

        $scope.getJuca = () => {
            return $scope.juca
        }

        function processaEventoRecebido (ev) {
            var response = JSON.parse(ev);
            //console.log(response);

            // DEBUG: Descomentar para testar o bug de qtd de aguardando e array ligacoes
            /* if (response.event === "FilasStatus") {
                response.filas.forEach(fila => {
                    if (fila.aguardando != fila.ligacoes.length) {
                        console.error(`FILA ${fila.nome} | Aguardando: ${fila.aguardando} | Ligações: ${fila.ligacoes.length}`);
                        //console.log(fila);
                    } else {
                        //console.log(`FILA ${fila.nome} | Aguardando: ${fila.aguardando} | Ligações: ${fila.ligacoes.length}`);
                    }
                });
            } */

            switch (response.event) {
                case 'Pong':
                    Pong(response);
                    break;
                case 'FilasStatus':
                    setQueueParams(response);
                    break;
                case 'AgenteStatus':
                    AgenteStatus(response);
                    break;
                case 'AgentePausa':
                    AgentePausa(response);
                    break;
                case 'AgenteAdicionado':
                    AgenteAdicionado(response);
                    break;
                case 'AgenteRemovido':
                    AgenteRemovido(response);
                    break;
                case 'Hangup':
                    Hangup(response);
                    break;
            }

            if ($scope.filas) $scope.statusConexao = "";
        }

        $scope.getAgentesFila = (fila) => {
            return $scope.agentes.filter(agente => agente.filas.includes(fila));
        };

        function AgenteHangupList (evento) {
            for (let agente of $scope.agentes_list) {
                if (agente.ligacoes_ativas && agente.ligacoes_ativas.length > 0) {
                    let index = agente.ligacoes_ativas.findIndex(l => l.uniqueid === evento.uniqueid);
                    if (index !== -1) {
                        agente.ligacoes_ativas.splice(index, 1);
                    }
                }
            }
        }

        function Hangup (evento) {
            ////console.log(`Analisando hangup linkedid = ${evento.linkedid}`);
            for (let agente of $scope.agentes) {
                if (!agente.ligacoes_ativas || agente.ligacoes_ativas.length <= 0) continue;

                let index = agente.ligacoes_ativas.findIndex(x => x.uniqueid === evento.uniqueid);
                if (index !== -1) {
                    // Remove a ligação do agente
                    agente.ligacoes_ativas.splice(index, 1);

                    // Verifica se era a única ligação do agente
                    if (agente.ligacoes_ativas.length <= 0) {
                        if (agente.pausa) {// Verifica se estava ocupado
                            // Se era ocupado, com auto-pausa-atendimento, reinicia o contador
                            agente.status = 10;
                            reiniciarTimerAgente(agente);
                        }
                    } else {
                        agente.status = 1;
                        agente.MinhaHora = new Date();
                        agente.time = 0;
                        reiniciarTimerAgente(agente);
                    }
                }
            }

            AgenteHangupList(evento);
        }

        function resetarTimerAgente (fila, agenteAnterior, agenteNovo) {
            // Verifica se houve mudança no status
            let houveMudancaDeStatus = agenteAnterior.status !== agenteNovo.status;

            // Se os dois são iguais, e permanecem em pausa. Verifica se a "Pausa" na realidade não é "Ocupado"
            if (!houveMudancaDeStatus && agenteAnterior.status === 10 && agenteAnterior.ligacoes_ativas != agenteNovo.ligacoes_ativas) {
                houveMudancaDeStatus = true;
            }

            ////console.log(`resetarTimerAgente: ${agenteAnterior.status} -> ${agenteNovo.status}\n${agenteAnterior.ligacoes_ativas.length} -> ${agenteNovo.ligacoes_ativas.length}`);

            if (houveMudancaDeStatus) {
                reiniciarTimerAgente(agenteAnterior);
            }
        }

        function reiniciarTimerAgente (agente) {
            let t = $scope.timers.filter(x => x.agente.nome === agente.nome);
            for (let timer of t) {
                ////console.log(`Resetando timer ${timer.div}`);
                timer.segundos = 0;
                timer.date = new Date();
                timer.agente.StatusTimeMs = 0;
            }
        }

        function atualizarAgenteNasFilas (agente, usarReferencia = false) {
            // Usado para, manualmente, definir as filas na qual o agente se encontra logado
            let filasDoAgente = [];

            // Itera em todas as filas
            for (let fila of $scope.filas) {
                // Pega os agentes da fila
                let agentes = fila.agentes || [];

                // Verifica se o agente especificado existe na fila
                let index = agentes.findIndex(x => x.nome === agente.nome);
                if (index !== -1) {
                    // Adiciona a fila na listagem
                    if (filasDoAgente.indexOf(fila.nome) === -1) filasDoAgente.push(fila.nome);

                    // Se tava com o Timer aberto do Agente inicia novo timer
                    resetarTimerAgente(fila.nome, agentes[index], agente);

                    // Atualiza os dados do agente
                    if (usarReferencia) {
                        // Como é por referência, quando atualizado em outros métodos, vai afetar esta fila automaticamente.
                        agentes[index] = agente;
                        agentes[index].filas = filasDoAgente;
                    } else {
                        // Esta parte atualiza cada propriedade individualmente, mantendo a instância anterior do agente
                        for (let property in agente) {
                            if (agente.hasOwnProperty(property)) agentes[index][property] = agente[property];
                        }
                    }

                    ////console.log(`Atualizando o agente ${agente.nome} na fila ${fila.nome}`);
                }
            }
        }

        function atualizarAgenteNaListagem (agente, usarReferencia = false) {
            // Atualiza o agente no array de agentes
            let index = $scope.agentes.findIndex(x => x.nome === agente.nome);
            if (index !== -1) {
                // Se o timer do agente estava aberto, reinicia o timer
                if ($scope.agentes[index].interval) resetarTimerAgente($scope.agentes[index], agente);

                // Atualiza os dados do agente
                if (usarReferencia) {
                    // Sendo por referência, quando atualizado em outros métodos, vai afetar esta fila automaticamente.
                    $scope.agentes[index] = agente;
                } else {
                    // Esta parte atualiza cada propriedade individualmente, mantendo a instância anterior do agente
                    for (let property in agente) {
                        if (agente.hasOwnProperty(property)) $scope.agentes[index][property] = agente[property];
                    }
                }
            } else {
                ////console.log("Novo agente -> ", agente);
                $scope.agentes.push(agente);
            }
        }

        function atualizarAgente (agente) {
            let object = { ...agente };
            atualizarAgenteNasFilas(object, true);
            atualizarAgenteNaListagem(object, true);
        }

        /**
         * Este método verifica as filas de um dado agente
         * Retornando false se o agente estiver apenas disponível em filas nas quais o usuário não possui acesso
         *
         * @param {any} agente
         * @returns {boolean}
         **/
        function verificarFilasDoAgente (agente) {
            return agente.filas.length < 0 || agente.filas.some(x => $scope.UserFilas.indexOf(x) !== -1);
        }

        function AgenteUpdate (newagente) {
            // Verifica se o agente já existe no array
            const index = $scope.agentes.findIndex(agente => agente.nome === newagente.nome);
            if (index !== -1) {
                // //console.log(`Achei agente velho ${newagente.nome} na posição ${index}, fila: ${newagente.fila}`);
                const agente = $scope.agentes[index];
                newagente.filas = agente.filas;
                newagente.time = agente.time;
                newagente.MinhaHora = agente.MinhaHora;

                // Verifica se é pausa nova e se não é sobre ocupado.
                if (newagente.pausa) {
                    if (agente.status != 3 && agente.status != 2) {
                        ////console.log('Pausa e não está ocupado...');
                        if (!agente.pausa) {
                            ////console.log('É pausa e não estava em pausa, mudando time do status');
                            newagente.time = 0;
                            newagente.MinhaHora = new Date();
                        }
                        $scope.agentes.splice(index, 1, newagente);
                    } else {
                        // Se ta ocupado marca o agente como pausa = 1 e o motivo sem mudar o status, para depois voltar ao status de pausa.
                        agente.pausa = newagente.pausa;
                        agente.pausa_motivo = newagente.pausa_motivo;
                        agente.motivo = newagente.motivo;
                        $scope.agentes.splice(index, 1, agente);
                    }
                } else {
                    // Se não for pausa, verifica se mudou de status, pois o Asterisk emite o mesmo evento para todas as filas do agente.
                    if (agente.status != newagente.status) {
                        ////console.log('Mudou de status, atualizando');
                        newagente.MinhaHora = new Date();
                        newagente.time = 0;
                        $scope.agentes.splice(index, 1, newagente);
                    }
                }

                atualizarAgente(newagente);
            } else {
                ////console.log(`Agente novo -> ${newagente.nome} na fila${newagente.fila}`);
                newagente.filas = [];
                newagente.filas.push(newagente.fila);

                newagente.MinhaHora = new Date();
                newagente.time = 0;

                $scope.agentes.push(newagente);
                ////console.log($scope.agentes);
            }
        }

        function AgenteStatusList (agente) {
            let agentfind = $scope.agentes_list.find(ag => ag.nome === agente.nome);
            if (agentfind) {
                if (agentfind.status != agente.status) {
                    agentfind.MinhaHora = new Date();
                    agentfind.status = agente.status;
                    agentfind.ligacoes_ativas = agente.ligacoes_ativas;
                    agentfind.motivo = agente.motivo;
                    agentfind.pausa = agente.pausa;
                    agentfind.StatusNome = agente.StatusNome;
                    agentfind.atendeu = agente.atendeu;
                    agentfind.efetuada = agente.efetuada;
                    if (agente.DataUltimaLigacao) agentfind.DataUltimaLigacao = agente.DataUltimaLigacao;
                }
            }
        }

        function AgenteStatus (evento) {
            AgenteUpdate(evento.agente);
            AgenteStatusList(evento.agente);
        }

        function AgentePausaList (agente) {
            let agentfind = $scope.agentes_list.find(ag => ag.nome === agente.nome);
            if (agentfind) {
                agentfind.MinhaHora = new Date();
                agentfind.status = agente.status;
                agentfind.ligacoes_ativas = agente.ligacoes_ativas;
                agentfind.motivo = agente.motivo;
                agentfind.pausa = agente.pausa;
                agentfind.StatusNome = agente.StatusNome;
            }
        }

        function AgentePausa (evento) {
            atualizarAgente(evento.agente);
            AgentePausaList(evento.agente);
            // Código legado
            /* $scope.filas.forEach(fila => {
                const index = fila.agentes.findIndex(ag => ag.nome === evento.agente.nome);
                if (index !== -1) {
                    const agente = fila.agentes[index];
                    var newagente = evento.agente;

                    // DEBUG: Atualizando a lista de agentes
                    AgenteUpdate(newagente);

                    // Se tava com o Timer aberto do Agente inicia novo timer
                    if (agente.interval) {
                        $interval.cancel(agente.interval);
                        delete (agente.interval);

                        if (agente.status != newagente.status) {
                            newagente.time = 0;
                            newagente.LocalDate = new Date();
                        }
                        else {
                            newagente.time = agente.time;
                            newagente.LocalDate = agente.LocalDate;
                        }

                        newagente.interval = $interval(function () {
                            newagente.time++;
                        }, 1000);
                    }

                    fila.agentes.splice(index, 1, newagente);
                }
            }); */
        }

        function AgenteAdicionadoList (agente) {
            let agentfind = $scope.agentes_list.find(ag => ag.nome === agente.nome);
            if (agentfind) {
                ////console.log(`AgenteAdicionadoList ja tem o agente: ${agente.nome}`);
                if (!agentfind.filas.some(f => f.nome === agente.fila)) {
                    ////console.log(`AgenteAdicionadoList Add a fila ${agente.fila} na lista do agente ${agente.nome}`);
                    agentfind.filas.push(agente.fila);
                }
            }
            else {
                if ($scope.UserFilas.includes(agente.fila)) {
                    let newagente = Object.assign({}, agente);
                    newagente.MinhaHora = new Date();
                    newagente.filas = [agente.fila];
                    $scope.agentes_list.push(newagente);
                }
            }
        }

        function AgenteAdicionado (evento) {
            let fila = $scope.filas.find(x => x.nome === evento.agente.fila);
            if (fila) {
                // Verifica se o agente já está na fila
                if (!fila.agentes.find(x => x.nome === evento.agente.nome)) {
                    fila.agentes.push(evento.agente);
                }

                // Atualiza a lista de filas do agente
                let indexAgente = $scope.agentes.findIndex(x => x.nome === evento.agente.nome);
                if (indexAgente !== -1) {
                    let agente = $scope.agentes[indexAgente];

                    // Fallback do array de filas
                    if (!agente.filas) agente.filas = [];

                    // Verifica se o agente não possui a fila, e se não possuir a adiciona na listagem
                    if (!agente.filas.find(x => x === evento.agente.fila)) agente.filas.push(evento.agente.fila);

                    // Se o agente está logado, porém em nenhuma fila na qual o atual usuário possui acesso
                    // Remove ele da listagem, assim evitando agentes com filas fantasmas no dashboard
                    if (!verificarFilasDoAgente(agente)) $scope.agentes.splice(indexAgente, 1);
                }
            }
            AgenteAdicionadoList(evento.agente);
            atualizarAgente(evento.agente);
        }

        function AgenteRemovidoList (agente) {
            let index = $scope.agentes_list.findIndex(ag => ag.nome === agente.nome);
            if (index !== -1) {
                ////console.log(`AgenteRemovidoList ja tem o agente: ${agente.nome}`);
                // Se tem mais de uma fila remove a fila
                if ($scope.agentes_list[index].filas.length > 1) {
                    ////console.log(`AgenteRemovidoList Add a fila ${agente.fila} na lista do agente ${agente.nome}`);
                    let idf = $scope.agentes_list[index].filas.findIndex(f => f === agente.fila);
                    if (idf !== -1) {
                        $scope.agentes_list[index].filas.splice(idf, 1);
                    }
                }
                // Se nao remove o agente
                else {
                    $scope.agentes_list.splice(index, 1);
                }
            }
        }

        function AgenteRemovido (evento) {
            let fila = $scope.filas.find(x => x.nome === evento.agente.fila);
            if (fila) {
                // Remove o agente da fila
                let index = fila.agentes.findIndex(x => x.nome === evento.agente.nome);
                if (index !== -1) {
                    fila.agentes.splice(index, 1);

                    // Atualiza a lista de filas do agente
                    let indexAgente = $scope.agentes.findIndex(x => x.nome === evento.agente.nome);
                    if (indexAgente !== -1) {
                        let agente = $scope.agentes[indexAgente];

                        // Fallback do array de filas
                        if (!agente.filas) agente.filas = [];

                        // Verifica se o agente possui a fila, e se tiver a remove
                        let indexFila = agente.filas.indexOf(evento.agente.fila);
                        if (indexFila !== -1) agente.filas.splice(indexFila, 1);

                        // Se o agente está logado, porém em nenhuma fila na qual o atual usuário possui acesso
                        // Remove ele da listagem, assim evitando agentes com filas fantasmas no dashboard
                        if (!verificarFilasDoAgente($scope.agentes[indexAgente])) $scope.agentes.splice(indexAgente, 1);
                        else atualizarAgente(evento.agente);
                    }
                }
            }

            AgenteRemovidoList(evento.agente);

            // atualizarAgente(evento.agente);
        }

        function AgenteAdicionadoNew (evento) {
            const index = $scope.agentes.findIndex(agente => agente.nome === evento.agente.nome);
            ////console.log(`Evento: ${evento.event}, Index: ${index}`);
            if (index !== -1) {
                ////console.log(`Achei, atualizando, Evento Fila: ${evento.agente.fila}`);
                const agente = $scope.agentes[index];
                if (!agente.filas) {
                    ////console.log('Não tem array de filas, criando')
                    evento.agente.filas = [];
                    evento.agente.filas.push(evento.agente.fila);
                }
                else {
                    ////console.log('Tem array de filas, verificando')
                    evento.agente.filas = agente.filas;
                    // Verifica a fila do evento
                    if (evento.agente.filas.indexOf(evento.agente.fila) === -1) {
                        ////console.log(`A fila ${evento.agente.fila} não está nas filas do agente, adicionando.`)
                        evento.agente.filas.push(evento.agente.fila);
                    }
                }
                evento.agente.MinhaHora = new Date();
                evento.agente.time = 0;
                $scope.agentes.splice(index, 1, evento.agente);
            }
            else {
                ////console.log('Não Achei, Novo');
                evento.agente.filas = [];
                evento.agente.filas.push(evento.agente.fila);
                evento.agente.MinhaHora = new Date();
                evento.agente.time = 0;
                $scope.agentes.push(evento.agente);
            }
        }

        function AgenteRemovidoNew (evento) {
            const index = $scope.agentes.findIndex(agente => agente.nome === evento.agente.nome);
            ////console.log(`Evento: ${evento.event}, Index: ${index}`);
            if (index !== -1) {
                const agente = $scope.agentes[index];

                ////console.log(`Achei Agente, Filas: ${agente.filas}`);
                if (agente.filas.length > 1) {
                    ////console.log(`Tem mais de uma fila, removendo fila ${evento.agente.fila}`)
                    agente.filas.splice(agente.filas.indexOf(evento.agente.fila), 1);
                    // Atualiza agente
                    $scope.agentes.splice(index, 1, agente);
                }
                else {
                    ////console.log(`Ultima fila do agente ${evento.agente.nome}, removendo ele.`);
                    $scope.agentes.splice(index, 1);
                }
            }
        }

        function Pong (ret) {
            ////console.log('PONG - Retorno do ping, alive = %s, qtdping = %s', ret.alive, qtdping);
            if (ret.alive) {
                qtdping = 0;
            }
        }

        $scope.load = function () {
            $scope.filtro.filas = $localStorage.Onlinefilas ? $localStorage.Onlinefilas : [];
        };

        $scope.setTipo = function (tipo, id) {
            $scope.janela[id] = tipo;
        };

        $scope.setPausa = function (motivo, agente) {
            var dados = {
                action: 'QueuePause',
                queue: agente.fila,
                stateinterface: agente.ramal,
                paused: true,
                motivo: motivo
            };
            $Store.emit('message', JSON.stringify(dados));
        };

        $scope.setTiraPausa = function (agente) {
            var dados = {
                action: 'QueueUnpause',
                queue: agente.fila,
                interface: agente.ramal
            };
            $Store.emit('message', JSON.stringify(dados));
        };

        $scope.setLogOff = function (agente) {
            var dados = {
                action: 'QueueRemove',
                queue: agente.fila,
                interface: agente.ramal
            };
            $Store.emit('message', JSON.stringify(dados));
        };

        $scope.setLogOff2 = function (agente) {
            var dados = {
                action: 'QueueRemove',
                queue: agente.fila,
                interface: agente.ramal
            };
            $Store.emit('message', JSON.stringify(dados));

            //$location.path('/logout');
        };

        $scope.setLogin = function (agente) {
            var dados = {
                action: 'QueueAdd',
                queue: agente.fila,
                interface: agente.ramal
            };
            $Store.emit('message', JSON.stringify(dados));
        };

        $scope.setUnPause = function (agente) {
            var dados = {
                action: 'QueueUnpause',
                queue: agente.fila,
                interface: agente.ramal
            };
            $Store.emit('message', JSON.stringify(dados));
        };

        $scope.reload = function () {
            //$scope.filas = [];
            //$scope.getQueueStatus(false);
        };

        $scope.getQueueStatus = function (fila) {
            var dados = {
                action: 'QueueStatus',
                queue: fila
            };
            $Store.emit('message', JSON.stringify(dados));
        };

        $scope.getQueueSummary = function (fila) {
            var dados = {
                action: 'QueueSummary',
                queue: fila
            };
            $Store.emit('message', JSON.stringify(dados));
        };

        $scope.getLigacaoAgente = function (agente) {
            if (agente.ligacoes_ativas.length === 0) return;
            return agente.ligacoes_ativas[0];
        };

        function AddOrUpdateFila (fila) {
            var tem = false;
            for (var j = 0; j < $scope.filas.length; j++) {
                if ($scope.filas[j].nome === fila.nome) {
                    tem = true;
                    var f = $scope.filas[j];

                    for (let property in fila) {
                        if (!fila.hasOwnProperty(property)) continue;
                        if (["agentes"].indexOf(property) !== -1) continue;

                        f[property] = fila[property];
                    }

                    if ($scope.nao_exibe_locais && $scope.nao_exibe_locais.ativado) {
                        ////console.log(`Não exibindo ligações menores que: ${$scope.nao_exibe_locais.tamanho}`);
                        f.ligacoes = fila.ligacoes.filter(function (lig) {
                            return lig.origem.length > $scope.nao_exibe_locais.tamanho;
                        });
                    } else {
                        f.ligacoes = fila.ligacoes;
                    }

                    // Se for uma fila whatsapp, email ou webchat, mapeia a propriedade "ligacoes"
                    if (fila.queue_type !== 1) {
                        f.ligacoes = fila.ligacoes.map(x => ({
                            origem: x.fromID.split('@')[0],
                            origen_nome: x.fromName,
                            inicio: x.dataIni,
                            posicao: x.posicao
                        }));
                    }

                    //for (let agente of fila.agentes) atualizarAgente(agente);

                    // Este loop está errado, o agente é atualizado e se não existente é adicionado na fila pelo primeiro método
                    // E o segundo método adiciona o agente de novo na fila, para não quebrar o funcionamento anterior o método foi mantido, porém com uma validação de duplicata
                    // Logo os registros não irão ser duplicados
                    /* angular.forEach(fila.agentes, function (agente) {
                        AddOrUpdateAgente($scope.filas[j], agente);
                        AgenteAdicionado({ event: 'AddOrUpdateFila', agente: agente });
                    }); */
                }
            }
            if (!tem) {
                ////console.log("FILA NÃO EXISTE! " + fila.nome);
                $scope.filas.push(fila);

                for (let agente of fila.agentes) atualizarAgente(agente);
            }
            groupAgentes();
        }

        function setQueueParams (ev) {
            if (ev.filas instanceof Array) {
                angular.forEach(ev.filas, function (evfila) {
                    // Se a fila não está na lista de filas do usuário ignora
                    if ($scope.UserFilas.indexOf(evfila.nome) === -1) return;
                    AddOrUpdateFila(evfila);
                });
            }
            else {
                // Se a fila não está na lista de filas do usuário ignora
                if ($scope.UserFilas.indexOf(ev.filas.nome) === -1) return;
                AddOrUpdateFila(ev.filas);
            }
        }

        $scope.getAbandonadas = function (fila) {
            if (!fila) return;
            fila.abandonadas_lista = [];
            fila.loading_abandonadas = true;
            var filtro = {
                dataini: $filter('date')(new Date(), 'dd/MM/yyyy'),
                datafim: $filter('date')(new Date(), 'dd/MM/yyyy'),
                fila: fila.nome,
                max: 0,
                status: 'Abandonada'
            };

            $http.post(options.api.rest + "/cdrfilas/filter", filtro).
                success(function (data) {
                    fila.loading_abandonadas = false;
                    fila.abandonadas_lista = data;
                });
        };

        $scope.getAgenteClass = function (agente) {
            switch (agente.status) {
                case 0:
                    return 'bg-color-blueLight';
                case 1:
                    return 'bg-color-green';
                case 2:
                    return 'bg-color-red';
                case 3:
                    return 'bg-color-red';
                case 4:
                    return 'bg-color-blueLight';
                case 5:
                    return 'bg-color-blueLight';
                case 6: // Ringing
                    return 'bg-color-orange';
                case 7:
                    return 'bg-color-orange';
                case 8:
                    return 'bg-color-yellow';

                // Pausa -- Nao existe no asterisk, criado para o paused = 1
                case 10: {
                    // Verifica se o agente tem ligações em curso
                    if (agente.ligacoes_ativas && agente.ligacoes_ativas.length > 0) {
                        // Se está em pausa, mas possui ligações, o cliente sip o colocou em AutoPausa para atendimento e classificação
                        // Mas devemos apresenta-lo como ocupado
                        return 'bg-color-red';
                    } else {
                        return 'bg-color-yellow';
                    }
                }

                default:
                    return 'bg-color-blueLight';
            }
        };

        /*
        Atualiza os dados de um agente quando vier evento de agente.
        */
        function AddOrUpdateAgente (fila, novoagente) {
            var tem = false;
            for (var j = 0; j < fila.agentes.length; j++) {
                var agente = fila.agentes[j];
                if (agente.nome === novoagente.nome) {
                    tem = true;
                    ////console.log(novoagente);
                    //if (novoagente.pausa && novoagente.ligacoes_ativas && novoagente.ligacoes_ativas.length > 0) {
                    //    //console.log('Forçado a ocupado...');
                    //    agente.status = 2;
                    //}
                    //if (novoagente.pausa && (!novoagente.pausa_motivo || novoagente.pausa_motivo == '')) {
                    //    //console.log('Caiu no else da pausa.');
                    //    return;
                    //}




                    if (agente.status != 2 && novoagente.ligacoes_ativas && novoagente.ligacoes_ativas.length > 0) {
                        ////console.log(`Fila: ${fila.nome}, Agente: ${agente.nome}, Forçado a ocupado...`);
                        ////console.log(novoagente);
                        agente.status = 2;
                    }
                    if (agente.status == 2 && novoagente.pausa && (!novoagente.pausa_motivo || novoagente.pausa_motivo == '')) {
                        ////console.log(`Fila: ${fila.nome}, Agente: ${agente.nome}, AutoPausa sobre acupado, não muda status...`);
                    }
                    else if (agente.status !== novoagente.status) {
                        ////console.log(`Fila: ${fila.nome}, Agente: ${agente.nome}, Zerando time, Status atual: ${agente.status}, novo status: ${novoagente.status}`);
                        ////console.log(novoagente);
                        agente.status = novoagente.status;
                        agente.time = 0;
                    }
                    agente.bgclass = $scope.getAgenteClass(agente);

                    agente.DataStatus = novoagente.DataStatus;
                    agente.StatusNome = novoagente.StatusNome;
                    agente.DataUltimaLigacao = novoagente.DataUltimaLigacao;
                    agente.ligacoes_ativas = novoagente.ligacoes_ativas;
                    agente.ligacoes = novoagente.ligacoes;
                    agente.AtendeuEm = novoagente.AtendeuEm;
                    agente.LigacaoAguardou = novoagente.LigacaoAguardou;
                    agente.LigacaoDuracao = novoagente.LigacaoDuracao;
                    agente.LigacaoFim = novoagente.LigacaoFim;
                    agente.atendeu = novoagente.atendeu;
                    agente.dump = novoagente.dump;
                    agente.efetuada = novoagente.efetuada;
                    agente.efetuada_agente_finalizou = novoagente.efetuada_agente_finalizou;
                    agente.efetuada_cliente_finalizou = novoagente.efetuada_cliente_finalizou;
                    agente.efetuada_naocompletou = novoagente.efetuada_naocompletou;
                    agente.finalizada = novoagente.finalizada;
                    agente.finalizou = novoagente.finalizou;
                    agente.naoatendeu = novoagente.naoatendeu;
                    agente.transferiu = novoagente.transferiu;
                    agente.motivo = novoagente.motivo;
                    agente.pausa = novoagente.pausa;
                    agente.pausa_motivo = novoagente.pausa_motivo;
                }
            }
            if (!tem) {
                ////console.log("AGENTE NÃO EXISTE! " + fila.nome + " - " + novoagente.nome);
                fila.agentes.push(novoagente);
            }
        }

        /*
        Processa o evento agente status
        */
        function AgenteStatusOld (ev) {
            angular.forEach($scope.filas, function (fila) {
                if (fila.nome === ev.agente.fila) {
                    AddOrUpdateAgente(fila, ev.agente);
                }
            });
            groupAgentes();
        }

        function removeAgente (a) {
            var ag = a.agente;
            for (var i = 0; i < $scope.filas.length; ++i) {
                if ($scope.filas[i].nome === ag.fila) {
                    for (var j = 0; j < $scope.filas[i].agentes.length; j++) {
                        if ($scope.filas[i].agentes[j].ramal === ag.ramal) {
                            if ($scope.filas[i].agentes[j].interval) {
                                ////console.log('Agente removido com interval ativo, parando...');
                                $interval.cancel($scope.filas[i].agentes[j].interval);
                            }
                            $scope.filas[i].agentes.splice(j, 1);
                        }
                    }
                }
            }
            groupAgentes();
        }

        $scope.getTotalOnline = function (fila) {
            let agentes = fila ? fila.agentes : $scope.agentes_list;

            return agentes.filter(function (item) {
                return getAgenteStatusReal(item) === 1;
            }).length;
        };

        $scope.getTotalPausa = function (fila) {
            let agentes = fila ? fila.agentes : $scope.agentes_list;

            return agentes.filter(function (item) {
                return getAgenteStatusReal(item) === 10;
            }).length;
        };

        $scope.getTotalOcupado = function (fila) {
            let agentes = fila ? fila.agentes : $scope.agentes_list;

            return agentes.filter(function (item) {
                return getAgenteStatusReal(item) === 2;
            }).length;
        };

        $scope.getTotalStatusAgentes = function (status) {
            return $scope.agentes_list.filter(function (item) {
                return getAgenteStatusReal(item) === status;
            }).length;
        };


        $scope.$on('$destroy', function () {
            console.log('Saiu do online...');
            $Store.removeListener('disconnect', onDisconect);
            $Store.removeListener('connect_failed', onDisconect);
            $Store.removeListener('connect_error', onDisconect);
            $Store.removeListener("reconnect_attempt", onReconect);
            $Store.removeListener('connect', onConect);
            $Store.removeListener('message', processaEventoRecebido);
        });

    });

});
