define(['modules/painelsupervisor/module', 'lodash', 'angular-highcharts'], function (module, _) {
    "use strict";

    module.registerController('PerformanceFilaCtrl', function ($scope, $http, $filter, $localStorage) {

        $scope.data = [];
        $scope.series = [];

        $scope.entrantes = {};
        $scope.entrantes.atendidas = 0;
        $scope.entrantes.abandonadas = 0;
        $scope.entrantes.transbordadas = 0;
        $scope.entrantes.total = 0;

        $scope.saintes = {};
        $scope.saintes.atendida = 0;
        $scope.saintes.nao_atendida = 0;
        $scope.saintes.ocupado = 0;
        $scope.saintes.falha = 0;
        $scope.saintes.total = 0;

        $scope.type = 'Pie';

        $scope.options = {
            //Boolean - Nao preencher com cor as curvas
            datasetFill: false
        };

        $scope.chartConfig = {
            chart: {
                plotBackgroundColor: null,
                plotBorderWidth: null,
                plotShadow: false
            },
            credits: {
                enabled: true,
                text: 'X5 Soluções - Xcontact',
                href: 'http://www.x5s.com.br'
            },
            title: {
                text: $scope.getWord('Performance da Fila'),
                useHTML: true
            },
            tooltip: {
                pointFormat: '{series.name}: <b>{point.percentage:.1f}%</b>'
            },
            plotOptions: {
                pie: {
                    allowPointSelect: true,
                    cursor: 'pointer',
                    dataLabels: {
                        enabled: true,
                        format: '<b>{point.name}</b>: {point.percentage:.1f} %',
                        style: {
                            color: (Highcharts.theme && Highcharts.theme.contrastTextColor) || 'black'
                        }
                    }
                }
            }
        };

        $scope.chartConfig2 = {
            chart: {
                plotBackgroundColor: null,
                plotBorderWidth: null,
                plotShadow: false
            },
            credits: {
                enabled: true,
                text: 'X5 Soluções - Xcontact',
                href: 'http://www.x5s.com.br'
            },
            title: {
                text: $scope.getWord('Performance da Fila'),
                useHTML: true
            },
            tooltip: {
                pointFormat: '{series.name}: <b>{point.percentage:.1f}%</b>'
            },
            plotOptions: {
                pie: {
                    allowPointSelect: true,
                    cursor: 'pointer',
                    dataLabels: {
                        enabled: true,
                        format: '<b>{point.name}</b>: {point.percentage:.1f} %',
                        style: {
                            color: (Highcharts.theme && Highcharts.theme.contrastTextColor) || 'black'
                        }
                    }
                }
            }
        };


        $scope.chartConfig3 = {
            chart: {
                plotBackgroundColor: null,
                plotBorderWidth: null,
                plotShadow: false
            },
            credits: {
                enabled: true,
                text: 'X5 Soluções - Xcontact',
                href: 'http://www.x5s.com.br'
            },
            title: {
                text: $scope.getWord('Total geral'),
                useHTML: true
            },
            tooltip: {
                pointFormat: '{series.name}: <b>{point.percentage:.1f}%</b>'
            },
            plotOptions: {
                pie: {
                    allowPointSelect: true,
                    cursor: 'pointer',
                    dataLabels: {
                        enabled: true,
                        format: '<b>{point.name}</b>: {point.percentage:.1f} %',
                        style: {
                            color: (Highcharts.theme && Highcharts.theme.contrastTextColor) || 'black'
                        }
                    }
                }
            }
        };

        $scope.onClick = function (points, evt) {
            console.log(points, evt);
        };


        $scope.getFilas = function () {
            $http.get(options.api.restv2 + "/filas?max=-1").
                success(function (data) {
                    // Voz                  -> 1
                    // WebChat              -> 2
                    // WhatsApp             -> 3
                    // E-mail               -> 4
                    // WhatsApp (Oficial)   -> 5

                    const tiposDeFilasAceitas = [
                        1 /* Voz */
                    ];

                    // Filtra as filas, ignorando filas de webchat e e-mail
                    $scope.filas = data.dados.filter(x => tiposDeFilasAceitas.indexOf(x.queue_type) !== -1 && $localStorage.User.filas.indexOf(x.name) !== -1);
                });
        };

        $scope.filterFilas = function (query) {
            return $scope.filas.map(x => x.name).filter(x => x.toLowerCase().indexOf(query.toLowerCase()) != -1);
        };

        $scope.getSelfila = function () {
            if (!$scope.filtro.fila || $scope.filtro.fila.length === 0) return $scope.getWord('Todas');
            else return _.values(_.pluck($scope.filtro.fila, "text")).join(",");
            //_.map($scope.filtro.fila, function(valor, key){ return num * 3; }); _.values($scope.filtro.fila).join(",");
        };

        $scope.getSelfila2 = function () {
            if (!$scope.filtros.fila || $scope.filtros.fila.length === 0) return $scope.getWord('Todas');
            else return _.values(_.pluck($scope.filtros.fila, "text")).join(",");
            //_.map($scope.filtro.fila, function(valor, key){ return num * 3; }); _.values($scope.filtro.fila).join(",");
        };

        $scope.getAgentes = function () {
            $http.get(options.api.restv3 + "/agente/all").
                success(function (data) {
                    $scope.agentes = data.dados;
                });
        };

        $scope.filterAgentes = function (query) {
            return _.sortBy($scope.agentes, 'fullname').filter(function (agente) {
                if ($scope.filtro.fila && $scope.filtro.fila.length > 0) {
                    for (var i = 0; i < $scope.filtro.fila.length; i++) {
                        if (agente.filas && agente.filas.indexOf($scope.filtro.fila[i].text) !== -1) {
                            return agente.fullname.toLowerCase().indexOf(query.toLowerCase()) !== -1;
                        }
                        else if (agente.fila && agente.fila.indexOf($scope.filtro.fila[i].text) !== -1) {
                            return agente.fullname.toLowerCase().indexOf(query.toLowerCase()) !== -1;
                        }
                    }
                }
                else {
                    return agente.fullname.toLowerCase().indexOf(query.toLowerCase()) !== -1;
                }
            });
        };

        function TimeTosec(time) {
            if (!time) return 0;
            var tt = time.split(":");
            return parseInt(tt[0]) * 3600 + parseInt(tt[1]) * 60 + parseInt(tt[2]) * 1;
        };

        function SecToTime(seconds) {
            if (!seconds) return '00:00:00';
            var date = new Date(1970, 0, 1);
            date.setSeconds(seconds);
            return date.toTimeString().replace(/.*(\d{2}:\d{2}:\d{2}).*/, "$1");
        };

        function getTempoMedioSegundos(segundos, total) {
            if (segundos == '0' || total == '0') return 0;
            return Math.round(segundos / total);
        };

        function calcularMedias(r) {
            if (r > 0) {
                if (r.tma > 0) r.tma = getTempoMedioSegundos(r.tma, r.total);
                r.tma = SecToTime(r.tma);
                if (r.tme > 0) r.tme = getTempoMedioSegundos(r.tme, r.total);
                r.tme = SecToTime(r.tme)
                if (r.abandonadas && r.tmab > 0) r.tmab = getTempoMedioSegundos(r.tmab, r.abandonadas);
                r.tmab = SecToTime(r.tmab)
            }
        }

        // Chamada para primeira pagina
        $scope.load = function () {
            $scope.filas = [];
            $scope.agentes = [];
            $scope.filtro = {};

            //$scope.filtro.dataini = hoje.getDate();
            $scope.filtro.dataini = new Date();
            $scope.filtro.datafim = new Date();

            $scope.filtro.horaini = '00:00';
            $scope.filtro.horafim = '23:59';

            $scope.filtros = angular.copy($scope.filtro);

            $scope.getFilas();
            $scope.getAgentes();
            $scope.getGrafico();
        };

        $scope.getGrafico = function () {
            $scope.loading = true;

            var filtros = angular.copy($scope.filtro);
            filtros.data_ini = $filter('date')(filtros.dataini, 'yyyy-MM-dd') + ' ' + filtros.horaini + ':00';
            filtros.data_fim = $filter('date')(filtros.datafim, 'yyyy-MM-dd') + ' ' + filtros.horafim + ':59';
            delete filtros.dataini;
            delete filtros.datafim;
            delete filtros.horaini;
            delete filtros.horafim;

            //Filas
            console.log($scope.filtro);
            if ($scope.filtro.fila && $scope.filtro.fila.length > 0) {
                // filtros.filas = JSON.stringify($scope.filas.filter((x)=> {return filtros.fila.includes(x.id);}));
                filtros.filas = JSON.stringify($scope.filtro.fila.map(x => { return x.text }));

                console.log(filtros.filas);

                //filtros.filas = JSON.stringify($scope.filas.filter(x => filtros.fila.find(y => y.text === x)));
            }
            else {
                filtros.filas = JSON.stringify($localStorage.User.filas);
            }
            delete filtros.fila;

            //Agentes
            if (filtros.agente && filtros.agente.length > 0) {
                // filtros.agentes = JSON.stringify(filtros.agente.map((x)=>{return x.nome;}));
                filtros.agentes = JSON.stringify(filtros.agente.map(x => x.fullname || x.nome));
            }
            delete filtros.agente;

            var par = [];
            if (filtros) {
                angular.forEach(filtros, function (v, k) {
                    if (v) par.push(k + "=" + encodeURI(v));
                });
            }
            var pars = "";
            if (par.length > 0) {
                pars = "&" + par.join("&");
            }

            $http.get(options.api.restv2 + "/filas/ligacoes?max=-1" + pars).success(function (data) {
                //Entrantes
                $scope.entrantes.atendidas = 0;
                $scope.entrantes.abandonadas = 0;
                $scope.entrantes.transbordadas = 0;
                $scope.entrantes.total = 0;
                $scope.rows = [];

                let entrantes = data.dados.filter((x) => { return x.sentido == 1; });
                if (entrantes && Array.isArray(entrantes)) {
                    $scope.rows = _.chain(entrantes)
                        .sortBy('fila')
                        .groupBy('fila')
                        .map((vf, kf) => {
                            let fdata = {
                                fila: kf,
                                atendidas: 0,
                                abandonadas: 0,
                                transbordadas: 0,
                                tme: 0,
                                tma: 0,
                                tmab: 0,
                                total: 0,
                            };
                            _.chain(vf)
                                .sortBy('status')
                                .groupBy('status')
                                .map((v, k) => {
                                    fdata.total += v.length;
                                    switch (k) {
                                        case "Atendida":
                                            $scope.entrantes.atendidas += v.length;
                                            fdata.atendidas += v.length;
                                            if (fdata.atendidas > 0) {
                                                fdata.tme += v.reduce((acc, x) => { return acc + TimeTosec(x.espera); }, 0);
                                                fdata.tma += v.reduce((acc, x) => { return acc + TimeTosec(x.duracao); }, 0);
                                            }
                                            break;
                                        case "Abandonada":
                                            $scope.entrantes.abandonadas += v.length;
                                            fdata.abandonadas += v.length;
                                            if (fdata.abandonadas > 0)
                                                fdata.tmab += v.reduce((acc, x) => { return acc + TimeTosec(x.espera); }, 0);

                                            break;
                                        case "Transbordou":
                                            $scope.entrantes.transbordadas += v.length;
                                            fdata.transbordadas += v.length;
                                            // if(fdata.total > 0)
                                            // {
                                            //     fdata.tme += SecToTime(getTempoMedioSegundos(v.reduce((acc, x)=> { acc + TimeTosec(x.espera) }, 0), fdata.total));
                                            //     fdata.tma += SecToTime(getTempoMedioSegundos(v.reduce((acc, x)=> { acc + TimeTosec(x.duracao) }, 0), fdata.total));
                                            // }
                                            break;
                                    }
                                });
                            //Cálculo finais do tempos para apresentação
                            if (fdata.atendidas > 0) {
                                fdata.tma = getTempoMedioSegundos(fdata.tma, fdata.atendidas);
                                fdata.tme = getTempoMedioSegundos(fdata.tme, fdata.atendidas);
                            }
                            if (fdata.abandonadas > 0)
                                fdata.tmab = getTempoMedioSegundos(fdata.tmab, fdata.abandonadas);

                            fdata.tme = SecToTime(fdata.tme);
                            fdata.tma = SecToTime(fdata.tma);
                            fdata.tmab = SecToTime(fdata.tmab);
                            return fdata;
                        }).value();
                }
                $scope.entrantes.total = entrantes.length;

                //Saíntes
                $scope.saintes.atendida = 0;
                $scope.saintes.nao_atendida = 0;
                $scope.saintes.ocupado = 0;
                $scope.saintes.falha = 0;
                $scope.saintes.total = 0;
                $scope.rows2 = [];

                let saintes = data.dados.filter((x) => { return x.sentido == 2; });
                if (saintes && Array.isArray(saintes)) {
                    $scope.rows2 = _.chain(saintes)
                        .sortBy('fila')
                        .groupBy('fila')
                        .map((vf, kf) => {
                            let fdata = {
                                fila: kf,
                                atendida: 0,
                                nao_atendida: 0,
                                ocupado: 0,
                                falha: 0,
                                tma: 0,
                                tme: 0,
                                total: 0,
                            };
                            _.chain(vf)
                                .sortBy('status')
                                .groupBy('status')
                                .map((v, k) => {
                                    fdata.total += v.length;
                                    switch (k) {
                                        case "Atendida":
                                            $scope.saintes.atendida += v.length;
                                            fdata.atendida += v.length;
                                            if (fdata.total > 0) {
                                                fdata.tme += v.reduce((acc, x) => { return acc + TimeTosec(x.espera); }, 0);
                                                fdata.tma += v.reduce((acc, x) => { return acc + TimeTosec(x.duracao); }, 0);
                                            }
                                            break;
                                        case "Não atendida":
                                            $scope.saintes.nao_atendida += v.length;
                                            fdata.nao_atendida += v.length;
                                            break;
                                        case "Ocupado":
                                            $scope.saintes.ocupado += v.length;
                                            fdata.ocupado += v.length;
                                            break;
                                        case "Falha":
                                            $scope.saintes.falha += v.length;
                                            fdata.falha += v.length;
                                            break;
                                    }
                                });
                            //Cálculo finais do tempos para apresentação
                            if (fdata.atendida > 0) {
                                fdata.tma = getTempoMedioSegundos(fdata.tma, fdata.atendida);
                                fdata.tme = getTempoMedioSegundos(fdata.tme, fdata.atendida);
                            }
                            fdata.tme = SecToTime(fdata.tme);
                            fdata.tma = SecToTime(fdata.tma);

                            return fdata;
                        }).value();
                }

                $scope.saintes.total = saintes.length;

                var titulo = '';

                $scope.chartConfig.title = {
                    text: `${$scope.getWord('ENTRANTES')} - <b>${$scope.entrantes.total || 0}</b> ${$scope.getWord('ligações')}`
                };

                if ($scope.rows.length > 0) {
                    // if($scope.filtro.fila && $scope.filtro.fila.length > 1){
                    //     titulo = $scope.getWord('ENTRANTES') + '-' + $scope.getWord('Filas') + '<span style="text-transform: uppercase"> '+$scope.getSelfila()+'</span> - <b>'+$scope.entrantes.total+'</b>' + $scope.getWord('ligações');
                    // }
                    // else {
                    //     titulo = $scope.getWord('ENTRANTES') + '-' + $scope.getWord('Fila') + '<span style="text-transform: uppercase"> '+$scope.getSelfila()+'</span> - <b>'+$scope.entrantes.total+'</b>' + $scope.getWord('ligações');
                    // }

                    $scope.chartConfig.subtitle = {
                        text: $scope.getWord('De') + ' ' + $filter('date')($scope.filtro.dataini, 'dd-MM-yyyy') + ' ' + $scope.filtro.horaini + ' ' + $scope.getWord('até') + ' ' + $filter('date')($scope.filtro.datafim, 'dd-MM-yyyy') + ' ' + $scope.filtro.horafim
                    };

                    $scope.chartConfig.series = [
                        {
                            type: 'pie',
                            name: 'Total',
                            data: [
                                [$scope.getWord('Atendidas'), parseFloat((($scope.entrantes.atendidas / $scope.entrantes.total) * 100).toFixed(2))],
                                [$scope.getWord('Abandonadas'), parseFloat((($scope.entrantes.abandonadas / $scope.entrantes.total) * 100).toFixed(2))],
                                [$scope.getWord('Transbordadas'), parseFloat((($scope.entrantes.transbordadas / $scope.entrantes.total) * 100).toFixed(2))]
                            ]
                        }
                    ];
                }
                else {
                    $scope.chartConfig.series = [];
                }

                $scope.chartConfig2.title = {
                    text: `${$scope.getWord('SAINTES')} - <b>${$scope.saintes.total || 0}</b> ${$scope.getWord('ligações')}`
                };
                if ($scope.rows2.length > 0) {
                    // if($scope.filtro.fila && $scope.filtro.fila.length > 1){
                    //     titulo = $scope.getWord('SAINTES') + ' - '+ $scope.getWord('Filas') + '<span style="text-transform: uppercase"> '+$scope.getSelfila()+'</span> - <b>'+$scope.saintes.total+'</b> '+ $scope.getWord('ligações');
                    // }
                    // else {
                    //     titulo = $scope.getWord('SAINTES')+' - <b>'+$scope.saintes.total+'</b> '+ $scope.getWord('ligações');
                    // }

                    $scope.chartConfig2.subtitle = {
                        text: $scope.getWord('De') + ' ' + $filter('date')($scope.filtro.dataini, 'dd-MM-yyyy') + ' ' + $scope.filtro.horaini + ' ' + $scope.getWord('até') + ' ' + $filter('date')($scope.filtro.datafim, 'dd-MM-yyyy') + ' ' + $scope.filtro.horafim
                    };

                    $scope.chartConfig2.series = [
                        {
                            type: 'pie',
                            name: 'Total',
                            data: [
                                [$scope.getWord('Atendida'), parseFloat((($scope.saintes.atendida / $scope.saintes.total) * 100).toFixed(2))],
                                [$scope.getWord('Não atendida'), parseFloat((($scope.saintes.nao_atendida / $scope.saintes.total) * 100).toFixed(2))],
                                [$scope.getWord('Ocupado'), parseFloat((($scope.saintes.ocupado / $scope.saintes.total) * 100).toFixed(2))],
                                [$scope.getWord('Falha'), parseFloat((($scope.saintes.falha / $scope.saintes.total) * 100).toFixed(2))]
                            ]
                        }
                    ];
                }
                else {
                    $scope.chartConfig2.series = [];
                }

                $scope.chartConfig3.title = {
                    text: `${$scope.getWord('GERAL')} - <b>${($scope.entrantes.total || 0) + ($scope.saintes.total || 0)}</b> ${$scope.getWord('ligações')}`
                };
                if ($scope.entrantes.total > 0 || $scope.saintes.total > 0) {
                    // if($scope.filtro.fila && $scope.filtro.fila.length > 1){
                    //     titulo = $scope.getWord('GERAL')+' - '+$scope.getWord('Filas')+' <span style="text-transform: uppercase"> '+$scope.getSelfila()+'</span> <b>'+($scope.entrantes.total+$scope.saintes.total)+'</b> '+$scope.getWord('ligações');
                    // }
                    // else {
                    //     titulo = $scope.getWord('GERAL')+' - '+$scope.getWord('Fila')+' <span style="text-transform: uppercase"> '+$scope.getSelfila()+'</span> - <b>'+($scope.entrantes.total+$scope.saintes.total)+'</b> '+$scope.getWord('ligações');
                    // }

                    $scope.chartConfig3.subtitle = {
                        text: $scope.getWord('De') + ' ' + $scope.filtro.dataini + ' ' + $scope.filtro.horaini + ' ' + $scope.getWord('até') + ' ' + $scope.filtro.datafim + ' ' + $scope.filtro.horafim
                    };

                    $scope.chartConfig3.series = [
                        {
                            type: 'pie',
                            name: 'Total',
                            data: [
                                [$scope.getWord('Entrantes'), parseFloat((($scope.entrantes.total / ($scope.entrantes.total + $scope.saintes.total)) * 100).toFixed(2))],
                                [$scope.getWord('Saintes'), parseFloat((($scope.saintes.total / ($scope.entrantes.total + $scope.saintes.total)) * 100).toFixed(2))]
                            ]
                        }
                    ];
                }
                else {
                    $scope.chartConfig3.series = [];
                }

                $scope.loading = false;
            });
        };
    });
});
