define([
    'angular',
    'angular-couch-potato',
    'lodash',
    'angular-ui-router',
    'angular-resource',
    'isteven-multi-select',
    'ngTagsInput',
    'bootstrap-toggle'

], function (ng, couchPotato, _) {
    'use strict';

    var module = ng.module('app.ramais', [
        'ui.router',
        'ngResource',
        'isteven-multi-select',
        'ngTagsInput',
        'toggle-switch'
    ]);


    couchPotato.configureApp(module);

    module.config(function ($stateProvider, $couchPotatoProvider) {

        $stateProvider
            .state('app.ramais', {
                url: '/ramais',                
                data: {
                    title: 'Ramais',
                    permissions: {
                        only: ['app.ramais']
                    }
                },                
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/ramais/views/lista.html',
                        controller: 'RamaisCtrl',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/ramais/controllers/RamaisCtrl',
                                'modules/ramais/directives/ramalPopup'
                            ])
                        }                     
                    }
                }
            })
            
            .state('app.ramais.editar', {
                url: '/editar/:id',
                data: {
                    title: 'Ramal',
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/ramais/views/form.html',
                        controller: 'RamaisCtrl',
                        parent: 'app.ramais',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/ramais/controllers/RamaisCtrl',
                                'modules/ramais/directives/ramalPopup'
                            ])
                        }
                    }
                }
            })
            
            .state('app.ramais.novo', {
                url: '/novo',
                data: {
                    title: 'Novo Ramal',
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/ramais/views/form.html',
                        controller: 'RamaisCtrl',
                        parent: 'app.ramais',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/ramais/controllers/RamaisCtrl',
                                'modules/ramais/directives/ramalPopup'
                            ])
                        }
                    }
                }
            })
            
            .state('app.ramais.ver', {
                url: '/ver/:id',
                data: {
                    title: 'Ramal',
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/ramais/views/form.html',
                        controller: 'RamaisCtrl',
                        parent: 'app.ramais',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/ramais/controllers/RamaisCtrl',
                                'modules/ramais/directives/ramalPopup'
                            ])
                        }
                    }
                }
            })
    });

    module.run(function ($couchPotato,Permission,$localStorage,ModuloPermissao) {
        module.lazy = $couchPotato;        
        Permission.defineRole('app.ramais', function () {
            if(!$localStorage.User || !ModuloPermissao.UsuarioTemModulo("app.ramais",$localStorage.User.modulos)){
               $localStorage.msg = {
                   tipo: "Erro",
                   txt: "Você não tem acesso aos Ramais."
               };               
               return false;
            }            
            else {                
                return true;         
            }
        });
    });

    return module;

});