define(['modules/rotas/module'], function (module) {
    "use strict";

    return module.registerController('RotasCtrl', function ($scope, $http, $stateParams, $rootScope) {
        $scope.row = {};
        $scope.rows2 = {};
        $scope.campos_disable = false;
        $scope.filtro = {};
        $scope.filtro.tipo = [];
        $scope.filtro.grupo = [];

        $scope.tipos = [
            { valor: 'Entrada', nome: 'Entrada' },
            { valor: 'Saida', nome: 'Saída' },
            { valor: 'URA', nome: 'URA' },
            { valor: 'URA_MENSAGEM', nome: 'URA Mensagem' },
        ];

        $scope.filterTipos = function (query) {
            return $scope.tipos.filter(function (t) {
                return t.nome.toLowerCase().indexOf(query.toLowerCase()) !== -1;
            });
        };

        $scope.getGrupos = function (fila) {
            $http.get(options.api.restv2 + "/rotas/grupos?max=-1&order=%5B%7B%22campo%22%3A%22context%22%7D%5D").
                success(function (data) {
                    $scope.contextos = data.dados;
                });
        };

        $scope.filterGrupos = function (query) {
            return $scope.contextos.filter(function (contexto) {
                if ($scope.filtro.tipo && $scope.filtro.tipo.length > 0) {
                    for (var i = 0; i < $scope.filtro.tipo.length; i++) {
                        if (contexto.sentido && contexto.sentido.indexOf($scope.filtro.tipo[i].valor) !== -1) {
                            return contexto;
                        }
                    }
                }
                else {
                    return contexto.context.toLowerCase().indexOf(query.toLowerCase()) !== -1;
                }
            });
        };

        $scope.trocacontexto = function () {
            $scope.context = $scope.row.context.context;
            angular.forEach($scope.rotas, function (r) {
                r.context = $scope.context;
            });
        };

        $scope.filterFunction = function (element) {
            return element.delete ? false : true;
        };

        $scope.AddItem = function (prio, contexto, ext) {
            var d = { exten: ext, priority: parseInt(prio) + 1, app: '', appdata: '', grupo: contexto };
            $scope.pop.row.splice(prio + 1, 0, d);
            //$scope.pop.row.push(d);
        };

        $scope.DelItem = function (id) {
            $scope.pop.row.splice(id, 1);
            //$scope.pop.row.push(d);
        };

        $scope.ItemMove = function (fromIndex, toIndex) {
            var element = $scope.pop.row[fromIndex];
            $scope.pop.row.splice(fromIndex, 1);
            $scope.pop.row.splice(toIndex, 0, element);
        };

        $scope.SaveItem = function () {
            //return console.log($scope.pop);

            angular.forEach($scope.pop.row, function (r) {
                var index = $scope.pop.row.indexOf(r);
                //if ($scope.pop.grupo) r.grupo = $scope.pop.geral.context;
                r.grupo = $scope.pop.grupo;
                r.exten = $scope.pop.rota;
                r.priority = index + 1;
                r.nome = $scope.pop.nome;
            });

            //console.log($scope.pop);

            $http.put(`${options.api.restv4}/rotareplace/${$scope.pop.rota}/${$scope.pop.grupo}`, $scope.pop.row).
                success(function (data) {
                    $.smallBox({
                        title: "SUCESSO!!",
                        content: "<i class='fa fa-check'></i> <i>Salvo com sucesso!</i>",
                        color: "#739E73",
                        timeout: 2000
                    });
                    $scope.load();
                });
        };

        $scope.filter = function () {
            $scope.load_filter = true;
            $scope.filteredRT = JSON.parse(JSON.stringify($scope.reminderTypes));

            if ($scope.filtro.tipo && $scope.filtro.tipo.length > 0) {
                let arrayNomes = $scope.filtro.tipo.map(item => item.valor);
                let ret = Object.entries($scope.filteredRT).filter(item => item[1].some(r => arrayNomes.includes(r.rotaGrupo[0].sentido)));
                $scope.filteredRT = Object.fromEntries(ret);
            }
            if ($scope.filtro.grupo && $scope.filtro.grupo.length > 0) {
                let arrayNomes = $scope.filtro.grupo.map(item => item.context);
                let ret = Object.entries($scope.filteredRT).filter(item => item[1].some(r => arrayNomes.includes(r.rotaGrupo[0].nome)));
                $scope.filteredRT = Object.fromEntries(ret);
            }
            $scope.load_filter = false;
        };

        // Chamada para primeira pagina
        $scope.load = function () {
            $scope.carregando = true;
            $scope.getGrupos();

            $http.get(`${options.api.restv4}/rotas`).
                success(function (data) {
                    if (data) {
                        let f1 = data.filter(f => f.priority == 1);
                        f1.sort(function (a, b) {
                            if (a.exten > b.exten) {
                                return 1;
                            }
                            if (a.exten < b.exten) {
                                return -1;
                            }
                            // a must be equal to b
                            return 0;
                        });
                        $scope.reminderTypes = _.groupBy(_.sortBy(f1, "grupo"), 'grupo');
                        $scope.filteredRT = JSON.parse(JSON.stringify($scope.reminderTypes));
                        $scope.filter();
                    }
                    $scope.carregando = false;
                });
        };

        $scope.delete = function (id) {
            $http.delete(options.api.restv4 + "/rota/" + id).
                success(function (s) {
                    $.smallBox({
                        title: "SUCESSO!!",
                        content: "<i class='fa fa-check'></i> <i>Rota apagada com sucesso!</i>",
                        color: "#739E73",
                        timeout: 2000
                    });

                    $scope.load();
                });
        };

        $scope.confirma = function (row) {
            $.x5Box({
                title: "<b>ATENÇÃO</b> pode apagar vários registros.",
                content: "Tem certeza que quer remover as rotas com prefixo " + row.exten + " do grupo " + row.grupo + "? <p><b>TODAS</b> as rotas com prefixo " + row.exten + " serão apagadas do grupo " + row.context + ".</p><p>Caso queira apagar apenas um registro edite a rota.</p> <p class='text-align-right'><a id='yes' href-void class='btn btn-danger btn-sm btncallback'>Apagar</a> <a id='no' href-void class='btn btn-primary btn-sm btncallback'>Cancelar</a></p>",
                color: "#C46A69",
                //timeout: 8000,
                icon: "fa fa-warning shake animated"
            }, function (ButtonPressed) {
                if (ButtonPressed === "Apagar") {
                    $scope.delete2(row.exten, row.grupo);
                }
            });
        };

        $scope.ConfirmaLimpaGrupo = function (grupo) {
            $.x5Box({
                title: "<b>ATENÇÃO</b> pode apagar vários registros.",
                content: "Tem certeza que quer remover <b>TODAS</b> as rotas do grupo " + grupo + "?</p> <p class='text-align-right'><a id='yes' href-void class='btn btn-danger btn-sm btncallback'>Apagar</a> <a id='no' href-void class='btn btn-primary btn-sm btncallback'>Cancelar</a></p>",
                color: "#C46A69",
                //timeout: 8000,
                icon: "fa fa-warning shake animated"
            }, function (ButtonPressed) {
                if (ButtonPressed === "Apagar") {
                    $scope.limpa_grupo(grupo);
                }
            });
        };

        $scope.limpa_grupo = function (grupo) {
            $http.delete(options.api.restv4 + "/limpa_grupo/" + grupo).
                success(function (s) {
                    $.smallBox({
                        title: "SUCESSO!!",
                        content: "<i class='fa fa-check'></i> <i>Grupo limpo com sucesso!</i>",
                        color: "#739E73",
                        timeout: 2000
                    });

                    $scope.load();
                });
        };

        // Por prefixo e contexto
        $scope.delete2 = function (prefixo, grupo) {
            $http.delete(`${options.api.restv4}/rota_prefixo_grupo/${prefixo}/${grupo}`).
                success(function (s) {
                    $.smallBox({
                        title: "SUCESSO!!",
                        content: "<i class='fa fa-check'></i> <i>Rota apagada com sucesso!</i>",
                        color: "#739E73",
                        timeout: 2000
                    });

                    $scope.load();
                });
        };

        $scope.showpopclonegrupo = function (grupo) {
            $scope.clone = {};
            $scope.clone.grupo_origem = grupo;

            $scope.showPopUpClone = true;
        };

        $scope.showCloneRota = (rota) => {
            $scope.clone = {};
            $scope.clone.rota = rota.exten;
            $scope.clone.grupo_origem = rota.grupo;

            $scope.showPopUpClone = true;
        }

        $scope.SaveClone = function (f1) {
            if (f1.$valid) {
                if ($scope.clone.rota) {
                    $http.post(`${options.api.restv4}/rota_clonar`, $scope.clone).
                        success(function (data) {
                            $.smallBox({
                                title: "SUCESSO!!",
                                content: "<i class='fa fa-check'></i> <i>Rota " + $scope.clone.rota + " do grupo " + $scope.clone.grupo_origem + " clonada parar grupo <b>" + $scope.clone.grupo_destino + "</b> com sucesso.</i>",
                                color: "#739E73",
                                timeout: 2000
                            });
                            $scope.load();
                        });
                }
                else {
                    $http.post(`${options.api.restv4}/rota_grupo_clonar`, $scope.clone).
                        success(function (data) {
                            $.smallBox({
                                title: "SUCESSO!!",
                                content: "<i class='fa fa-check'></i> <i>Rotas clonadas do grupo " + $scope.clone.grupo_origem + " parar grupo <b>" + $scope.clone.grupo_destino + "</b> com sucesso.</i>",
                                color: "#739E73",
                                timeout: 2000
                            });
                            $scope.load();
                        });
                }
            }
        };

        $scope.showpopup = function (row) {
            console.log(row);

            $scope.pop = {};
            //$scope.pop.geral = false;
            //$scope.pop.rota_name = null;
            $scope.pop.rota = null;
            //$scope.pop.rota_original = null;
            $scope.pop.row = [];
            if (row && row.exten) {
                row.load = true;
                //$scope.editando = true;
                //$scope.pop.titulo = 'Editando';
                $scope.pop.rota = row.exten;
                $scope.pop.grupo = row.grupo;
                //$scope.pop.rota_original = row.exten;
                //$scope.pop.sub2_titulo = row.grupo;

                $http.get(`${options.api.restv4}/rota_prefixo_grupo/${row.exten}/${row.grupo}`).
                    success(function (data) {
                        let dados = data.map(r => {
                            delete r.id;
                            delete r.rotaGrupo;
                            return r;
                        })
                        dados.sort((a, b) => (a.priority > b.priority) ? 1 : ((b.priority > a.priority) ? -1 : 0));

                        $scope.pop.row = dados;
                        $scope.pop.nome = $scope.pop.row[0].nome ? $scope.pop.row[0].nome : row.exten;
                        //$scope.pop.sub_titulo = $scope.pop.rota_name;
                        $scope.showModalPopUp = true;
                        row.load = false;
                    });
            }
            else {
                //$scope.editando = false;

                $scope.showModalPopUp = true;
                if (!row) {
                    //$scope.pop.geral = true;
                    //$scope.pop.titulo = 'Nova rota';
                    //$scope.pop.sub_titulo = null;
                    //$scope.pop.sub2_titulo = null;

                    $scope.AddItem(0, '', '');
                }
                else {
                    $scope.pop.grupo = row;
                    //$scope.pop.titulo = 'Nova rota em';
                    //$scope.pop.sub_titulo = row;
                    //$scope.pop.sub2_titulo = null;
                    $scope.AddItem(0, row, '');
                }
            }
        };

    });
});