define(['modules/rotas/module', 'jquery-maskedinput', 'jquery-validation'], function (module) {

    'use strict';

    return module.registerDirective('rotasFormValidate', function () {
        return {
            restrict: 'E',
            replace: true,
            templateUrl: 'app/modules/rotas/views/form.tpl.html',
            scope: true,
            link: function (scope, form) {
               var validateOptions = {
                    errorElement: 'em',
                    errorClass: 'invalid',
                    highlight: function(element, errorClass, validClass) {
                        $(element).addClass(errorClass).removeClass(validClass);
                        $(element).parent().addClass('state-error').removeClass('state-success');
                    },
                    unhighlight: function(element, errorClass, validClass) {
                        $(element).removeClass(errorClass).addClass(validClass);
                        $(element).parent().removeClass('state-error').addClass('state-success');
                    },
                    errorPlacement : function(error, element) {
                        error.insertAfter(element.parent());
                    }
                };
                
               form.validate(angular.extend({
                    // Rules for form validation
                    rules : {
                        context : {
                            required : true
                        },
                        exten : {
                            required : true
                        },
                        priority : {
                            required : true
                        },
                        app : {
                            required : true
                        }                      
                    },
                    
                    submitHandler: function() { scope.$parent.Salvar() },

                    // Messages for form validation
                    messages : {
                        context : {
                            required : 'O contexto é obrigatorio.'
                        },
                        exten : {
                            required : 'A rota é obrigatoria.'
                        },
                        priority : {
                            required : 'A prioridade é obrigatoria.'
                        },
                        app : {
                            required : 'A aplicação é obrigatoria.'
                        }
                    }
                }, validateOptions));

            }
        }
    });
});
