define([
    'angular',
    'angular-couch-potato',
    'lodash',
    'angular-ui-router',
    'angular-resource',
    'isteven-multi-select',
    'ngTagsInput',
    'bootstrap-toggle'

], function (ng, couchPotato, _) {
    'use strict';

    var module = ng.module('app.tempos', [
        'ui.router',
        'ngResource',
        'isteven-multi-select',
        'ngTagsInput',
        'toggle-switch'
    ]);


    couchPotato.configureApp(module);

    module.config(function ($stateProvider, $couchPotatoProvider) {

        $stateProvider
            .state('app.tempos', {
                url: '/tempos',
                data: {
                    title: 'Tempos',
                    permissions: {
                        only: ['app.tempos']
                    }
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/tempos/views/lista.html',
                        controller: 'TempoCtrl',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/tempos/controllers/TempoCtrl',
                                'modules/tempos/controllers/FeriadoCtrl',
                                'modules/forms/directives/input/smartTimepicker',
                                'modules/forms/directives/input/smartClockpicker'
                            ])
                        }
                    }
                }
            })

            .state('app.tempos.editar', {
                url: '/editar/:id',
                data: {
                    title: 'Tempo',
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/tempos/views/form.html',
                        controller: 'TempoCtrl',
                        parent: 'app.tempos',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/tempos/controllers/TempoCtrl',
                                'modules/tempos/directives/TempoPopup'
                            ])
                        }
                    }
                }
            })

    });

    module.run(function ($couchPotato,Permission,$localStorage,ModuloPermissao) {
        module.lazy = $couchPotato;
        Permission.defineRole('app.tempos', function () {
            if(!$localStorage.User || !ModuloPermissao.UsuarioTemModulo("app.tempos",$localStorage.User.modulos)){
               $localStorage.msg = {
                   tipo: "Erro",
                   txt: "Você não tem acesso as definições de Tempo."
               };
               return false;
            }
            else {
                return true;
            }
        });
    });

    return module;

});
