"use strict";
define(['modules/uratexto/module'], function (module) {
    return module.registerController('uratextoCtrl', function ($scope, $http, $stateParams, $rootScope) {
        $scope.blocos = [
            {
                nome: 'Mensagem',
                icon: 'fa fa-comment',
                inputs: 1,
                outputs: 1,
                html: `<div>
	<div class="title-box">
		<i class="fa fa-comment"></i> Mensagem
	</div>
    <div class="box">        
		<p>Texto</p>
		<textarea ng-model="texto" style=" width: 210px;" df-mensagem></textarea>
    </div>    
</div>`
            },
            {
                nome: 'VerificarTurno',
                icon: 'fa fa-clock-o',
                inputs: 1,
                outputs: 2,
                html: `<div>
	<div class="title-box">
		<i class="fa fa-clock-o"></i> Verificar turnos
	</div>
    <div class="box">        
		<h4>Opção 1 - Turno OK</h4>
		<h4>Opção 2 - Fora de Turno</h4>
    </div>    
</div>`
            },
            {
                nome: 'API',
                icon: 'fa fa-cogs',
                inputs: 1,
                outputs: 2,
                html: `<div>
	<div class="title-box">
		<i class="fa fa-cogs"></i> API
	</div>
	<div class="box">
		<h3>Consulta cliente</h3>
		<button type="button" df-sequencia onclick="EditarJS(this.value)" class="btn btn-primary">Editar</button>
    </div>    
</div>`
            },
            {
                nome: 'Menu',
                icon: 'fa fa-sitemap',
                inputs: 1,
                outputs: 0,
                html: `<div>
	<div class="title-box">
		<i class="fa fa-sitemap"></i> Menu
    </div>
    <div class="box">
        <p>Texto</p>
		<textarea style=" width: 210px;" df-mensagem></textarea>
        <h4>
            Opções 
            <button type="button" df-sequencia onclick="AddMenuJS(this.value)" class="btn btn-success btn-sm"><i class='fa fa-plus'></i></button> 
            <button type="button" df-sequencia onclick="DelMenuJS(this.value)" class="btn btn-danger btn-sm"><i class='fa fa-trash'></i></button>
        </h4>        
    </div>    
    <div id="addlist" class="alt1" style="padding:10px;"></div>	    
</div>`
            },
        ]

        $scope.texto = 'Integração com ngModel';

        $scope.showpopup = function () {
            $scope.showUraPopup = true;
        }

        $scope.AddOutput = (id) => {
            $scope.editor.addNodeOutput(id);
        }

        $scope.DelOutput = (id, port) => {
            console.log(`Remove porta ${port} de ${id}`);
            $scope.editor.removeNodeOutput(id, port);
        }

        $scope.Editar = (p) => {
            console.log(p);
        }

        $scope.Limpar = () => {
            $scope.editor.clearModuleSelected();
            AddStart();
        }

        $scope.Salvar = () => {
            console.log(JSON.stringify($scope.editor.export(), null, 4));
        }

        $scope.AddNode = (name, pos_x, pos_y) => {
            console.log(`Addnode on angular ${name} on X=${pos_x} and Y=${pos_y}`);
            console.log($scope.editor.drawflow.drawflow.Home.data);

            const bloco = $scope.blocos.find(e => e.nome == name);
            const id = $scope.editor.addNode(bloco.nome, bloco.inputs, bloco.outputs, pos_x - 540, pos_y - 150, bloco.nome, {}, bloco.html);
            $scope.editor.updateNodeDataFromId(id, { sequencia: id });
            console.log(id);
        }

        function AddStart() {
            const bloco = `<div>
	<div class="title-box">
		<i class="fa fa-lg fa-play"></i> Incio
	</div>   
</div>`;
            $scope.editor.addNode('Start', 0, 1, 20, 30, 'Start', {}, bloco);
        }

        $scope.init = function () {
            console.log('Ura Texto');

            var id = document.getElementById("drawflow");
            $scope.editor = new Drawflow(id);
            $scope.editor.reroute = true;



            $scope.editor.start();

            AddStart();

            // Events!
            $scope.editor.on('nodeCreated', function (id) {
                console.log("Node created " + id);
            })

            $scope.editor.on('nodeRemoved', function (id) {
                console.log("Node removed " + id);
            })

            $scope.editor.on('nodeSelected', function (id) {
                console.log("Node selected " + id);
            })

            $scope.editor.on('moduleCreated', function (name) {
                console.log("Module Created " + name);
            })

            $scope.editor.on('moduleChanged', function (name) {
                console.log("Module Changed " + name);
            })

            $scope.editor.on('connectionCreated', function (connection) {
                console.log('Connection created');
                console.log(connection);
            })

            $scope.editor.on('connectionRemoved', function (connection) {
                console.log('Connection removed');
                console.log(connection);
            })

            $scope.editor.on('mouseMove', function (position) {
                //console.log('Position mouse x:' + position.x + ' y:' + position.y);
            })

            $scope.editor.on('nodeMoved', function (id) {
                console.log("Node moved " + id);
            })

            $scope.editor.on('zoom', function (zoom) {
                console.log('Zoom level ' + zoom);
            })

            $scope.editor.on('translate', function (position) {
                console.log('Translate x:' + position.x + ' y:' + position.y);
            })

            $scope.editor.on('addReroute', function (id) {
                console.log("Reroute added " + id);
            })

            $scope.editor.on('removeReroute', function (id) {
                console.log("Reroute removed " + id);
            })


        }
    });
});
