define([
    'angular',
    'angular-couch-potato',
    'lodash',
    'angular-ui-router',
    'angular-resource',
    'isteven-multi-select',
    'ngTagsInput',
    'bootstrap-toggle'
], function (ng, couchPotato, _) {
    'use strict';

    var module = ng.module('app.wizard_mensagens_ura', [
        'ui.router',
        'ngResource',
        'isteven-multi-select',
        'ngTagsInput',
        'toggle-switch'
    ]);
    couchPotato.configureApp(module);

    module.config(function($stateProvider, $couchPotatoProvider) {
        $stateProvider
            .state('app.wizard_mensagens_ura', {
                url: '/wizard_mensagens_ura',
                data: {
                    title: 'Wizard Mensagens URA',
                    permissions: {
                        only: ['app.wizard_mensagens_ura']
                    }
                },
                views: {
                    "content@app": {
                        templateUrl: 'app/modules/wizard_mensagens_ura/views/lista.html',
                        controller: 'WizardMensagensUraListaController',
                        resolve: {
                            deps: $couchPotatoProvider.resolveDependencies([
                                'modules/wizard_mensagens_ura/controllers/ListaController',
                                'modules/wizard_mensagens_ura/directives/wizardMensagensUraPopup',
                                'modules/forms/directives/input/smartTimepicker',
                                'modules/forms/directives/input/smartClockpicker',
                            ])
                        }
                    }
                }
            })
    });

    module.run(function ($couchPotato, Permission, $localStorage, ModuloPermissao) {
        module.lazy = $couchPotato;
        Permission.defineRole('app.wizard_mensagens_ura', function () {
            if(!$localStorage.User || !ModuloPermissao.UsuarioTemModulo("app.wizard_mensagens_ura", $localStorage.User.modulos)){
               $localStorage.msg = {
                   tipo: "Erro",
                   txt: "Você não tem acesso as definições de wizard_mensagens_ura."
               };
               return false;
            }
            else {
                return true;
            }
        });
    });

    return module;
});