"use strict";
(function () {
  angular
    .module("ngXcmobx", [])
    .factory("$Xcmobx", _storageFactory("localStorage"));
  function _storageFactory(storageType) {
    return [
      "$rootScope",
      "$window",
      "$localStorage",
      function ($rootScope, $window, $localStorage) {
        console.log("Chamou o Xcmobx");

        const { extendObservable, action } = require("mobx");

        if (options.api.ip_server == "localhost") {
          options.api.ip_server = $window.location.hostname;
          options.api.modo = $window.location.protocol;
          options.api.ami_port = options.api.modo === "http:" ? 3000 : 3003;
          options.api.ami = `${options.api.modo}//${options.api.ip_server}:${options.api.ami_port}`;
        } else {
          options.api.ami_port = options.api.modo === "http:" ? 3000 : 3003;
          options.api.ami = `${options.api.modo}//${options.api.ip_server}:${options.api.ami_port}`;
        }
        const io = require("socket-io2")(`${options.api.ami}`, {
          transports: ["websocket"],
          upgrade: false,
          autoConnect: false,
          reconnectionAttempts: 15,
        });

        class Ami {
          constructor() {
            extendObservable(this, {
              filas: [],
              agentes: [],
              statusConexao: "desconectado",
              addAgente: action(function (agente) {
                const fila = this.filas.find((f) => f.nome === agente.fila);
                if (fila) {
                  if (!fila.agentes) fila.agentes = [];
                  let agenteFind = fila.agentes.find((a) => {
                    if (a.id && agente.id) return a.id === agente.id;
                    else return a.nome === agente.nome;
                  });
                  if (agenteFind) {
                    agenteFind.status = agente.status;
                    agenteFind.pausa = agente.pausa;
                    agenteFind.pausa_motivo = agente.pausa_motivo;
                    agenteFind.status_date = agente.status_date;
                  } else {
                    fila.agentes.push(agente);
                  }
                }
                // Agente list
                let agentfind = this.agentes.find((a) => {
                  if (a.id && agente.id) return a.id === agente.id;
                  else return a.nome === agente.nome;
                });
                if (agentfind) {
                  if (!agentfind.filas) agentfind.filas = [];
                  if (!agentfind.filas.includes(fila.nome))
                    agentfind.filas.push(fila.nome);
                } else {
                  agente.filas = [fila.nome];
                  this.agentes.push(agente);
                }
              }),
              updateAgente: action(function (agente) {
                for (const fila of this.filas) {
                  if (fila) {
                    const ag = fila.agentes.find((a) => {
                      if (a.id && agente.id) return a.id === agente.id;
                      else return a.nome === agente.nome;
                    });
                    if (ag && ag.status !== 12) {
                      ag.status = agente.status;
                      ag.pausa = agente.pausa;
                      ag.pausa_motivo = agente.pausa_motivo;
                      ag.status_date = agente.status_date;
                      ag.ligacoes_ativas = agente.ligacoes_ativas;
                    }
                  }
                }
                // Agente list
                let agentfind = this.agentes.find((a) => {
                  if (a.id && agente.id) return a.id === agente.id;
                  else return a.nome === agente.nome;
                });
                if (agentfind) {
                  agentfind.status = agente.status;
                  agentfind.pausa = agente.pausa;
                  agentfind.pausa_motivo = agente.pausa_motivo;
                  agentfind.status_date = agente.status_date;
                  agentfind.ligacoes_ativas = agente.ligacoes_ativas;
                }
              }),
              delAgente: action(function (agente) {
                const fila = this.filas.find((f) => f.nome === agente.fila);
                if (fila) {
                  let agenteFind = fila.agentes.find((a) => {
                    if (a.id && agente.id) return a.id === agente.id;
                    else return a.nome === agente.nome;
                  });
                  if (agenteFind) {
                    agenteFind.status = 12;
                    agenteFind.status_date = new Date();
                  }
                }
                // Agente list
                let agentIdx = this.agentes.findIndex((a) => {
                  if (a.id && agente.id) return a.id === agente.id;
                  else return a.nome === agente.nome;
                });
                if (agentIdx !== -1) {
                  const agFilas = this.agentes[agentIdx].filas.slice();
                  if (agFilas.length <= 1) {
                    this.agentes.splice(agentIdx, 1);
                  } else {
                    let filaIdx = agFilas.indexOf(agente.fila);
                    if (filaIdx !== -1)
                      this.agentes[agentIdx].filas.splice(filaIdx, 1);
                  }
                }
              }),
              updateLigacaoAgente: action(function (ligacao) {
                // Agente list
                let agentfind = this.agentes.find(
                  (ag) => ag.id === ligacao.agente_id
                );
                let filaFind = this.filas.find((f) => f.nome === ligacao.fila);
                if (agentfind) {
                  if (ligacao.sentido === 1 && ligacao.status === 2)
                    agentfind.ligacoes_recebidas += 1;
                  if (ligacao.sentido === 2 && ligacao.status === 2)
                    agentfind.ligacoes_efetuadas += 1;
                }
                if (filaFind && ligacao.sentido === 2 && ligacao.status === 2)
                  filaFind.efetuadas += 1;
              }),
              addAguardandoFila: action(function (ligacao) {
                const fila = this.filas.find((f) => f.nome === ligacao.fila);
                if (fila) {
                  if (!fila.ligacoes_aguardando) fila.ligacoes_aguardando = [];
                  fila.ligacoes_aguardando.push(ligacao);
                }
              }),
              addAtendimentoAguardando: action(function (atendimento) {
                const fila = this.filas.find(
                  (f) => f.nome === atendimento.fila
                );
                if (fila) {
                  if (!fila.AtendimentosAguardando)
                    fila.AtendimentosAguardando = [];
                  fila.AtendimentosAguardando.push(atendimento);
                }
              }),
              delAtendimentoAguardando: action(function (atendimento) {
                const fila = this.filas.find(
                  (f) => f.nome === atendimento.fila
                );
                if (fila) {
                  fila.AtendimentosAguardando.splice(
                    fila.AtendimentosAguardando.findIndex(
                      (a) => a.atendimentoId === atendimento.atendimentoId
                    ),
                    1
                  );
                }
              }),
              FilaNovoAtendimento: action(function (atendimento) {
                const fila = this.filas.find(
                  (f) => f.nome === atendimento.fila
                );
                if (fila) {
                  if (!fila.TotalAtendimentosEntrantes)
                    fila.TotalAtendimentosEntrantes = 0;
                  fila.TotalAtendimentosEntrantes++;
                }
              }),
              FilaNovaMensagem: action(function (msg) {
                const fila = this.filas.find((f) => f.nome === msg.fila);
                if (fila) {
                  if (!fila.MsgEnviadas) fila.MsgEnviadas = 0;
                  if (!fila.MsgRecebidas) fila.MsgRecebidas = 0;

                  if (msg.sentido === "entrante") fila.MsgRecebidas++;
                  else fila.MsgEnviadas++;
                }
              }),
              addAtendidaFila: action(function (ligacao) {
                const fila = this.filas.find((f) => f.nome === ligacao.fila);
                if (fila) {
                  const idxLig = fila.ligacoes_aguardando.findIndex(
                    (l) => l.callid === ligacao.callid
                  );
                  if (idxLig !== -1) {
                    fila.ligacoes_aguardando.splice(idxLig, 1);
                    if (!fila.atendidas) fila.atendidas = 0;
                    fila.atendidas++;
                    if (!fila.total_espera) fila.total_espera = 0;
                    fila.total_espera += ligacao.espera;
                    if (ligacao.espera > 60) {
                      fila.esperas_maior++;
                    } else {
                      fila.esperas_menor++;
                    }
                    fila.tme = Math.round(fila.total_espera / fila.atendidas);
                    if (ligacao.espera > fila.max_espera)
                      fila.max_espera = ligacao.espera;
                  }
                }
              }),
              addFimLigacaoFila: action(function (ligacao) {
                const fila = this.filas.find((f) => f.nome === ligacao.fila);
                if (fila) {
                  if (!fila.total_falando) fila.total_falando = 0;
                  fila.total_falando += ligacao.falando;
                  fila.tma = Math.round(fila.total_falando / fila.atendidas);
                  if (ligacao.falando > fila.max_falando)
                    fila.max_falando = ligacao.falando;
                }
              }),
              addAbandonoFila: action(function (ligacao) {
                const fila = this.filas.find((f) => f.nome === ligacao.fila);
                if (fila) {
                  const idxLig = fila.ligacoes_aguardando.findIndex(
                    (l) => l.callid === ligacao.callid
                  );
                  if (idxLig !== -1) {
                    // Add abandono
                    if (!fila.ligacoes_abandonadas)
                      fila.ligacoes_abandonadas = [];
                    fila.ligacoes_abandonadas.push(ligacao);

                    // Remove do aguardando
                    fila.ligacoes_aguardando.splice(idxLig, 1);

                    // Recalcula times
                    if (!fila.abandonadas) fila.abandonadas = 0;
                    fila.abandonadas++;
                    if (!fila.total_abandono) fila.total_abandono = 0;
                    fila.total_abandono += ligacao.espera;
                    if (ligacao.espera > 60) {
                      fila.abandonos_maior++;
                    } else {
                      fila.abandonos_menor++;
                    }
                    fila.tmab = Math.round(
                      fila.total_abandono / fila.abandonadas
                    );
                    if (ligacao.espera > fila.max_abandono)
                      fila.max_abandono = ligacao.espera;
                  }
                }
              }),
              addTransbordoFila: action(function (ligacao) {
                const fila = this.filas.find((f) => f.nome === ligacao.fila);
                if (fila) {
                  const idxLig = fila.ligacoes_aguardando.findIndex(
                    (l) => l.callid === ligacao.callid
                  );
                  if (idxLig !== -1) {
                    fila.ligacoes_aguardando.splice(idxLig, 1);
                    if (!fila.transbordadas) fila.transbordadas = 0;
                    fila.transbordadas++;
                    if (!fila.total_transbordo) fila.total_transbordo = 0;
                    fila.total_abandono += ligacao.espera;
                    fila.tmab = Math.round(
                      fila.total_abandono / fila.abandonadas
                    );
                  }
                }
              }),
              populateAgentesList: () => {
                for (let fila of this.filas) {
                  for (let agente of fila.agentes) {
                    let agentfind = this.agentes.find((a) => {
                      if (a.id && agente.id) return a.id === agente.id;
                      else return a.nome === agente.nome;
                    });
                    if (agentfind) {
                      if (!agentfind.filas) agentfind.filas = [];
                      if (
                        !agentfind.filas.includes(fila.nome) &&
                        agente.status !== 12
                      )
                        agentfind.filas.push(fila.nome);
                      if (agente.status !== 12) {
                        agentfind.status = agente.status;
                        agentfind.pausa = agente.pausa;
                        if (agente.pausa === 1)
                          agentfind.pausa_motivo = agente.pausa_motivo;
                        if (
                          new Date(agente.status_date) >
                          new Date(agentfind.status_date)
                        ) {
                          agentfind.status_date = agente.status_date;
                        }
                      }
                    } else {
                      let newAgent = { ...agente };
                      if (agente.status !== 12) {
                        newAgent.filas = [fila.nome];
                      }
                      this.agentes.push(newAgent);
                    }
                  }
                }
              },
              PausarAgente: (ramal) => {
                console.log(`Chamou PausarAgente para ramal ${ramal}`);
                io.emit(
                  "PausarAgente",
                  { ramal, motivo: "Supervisor" },
                  (resposta) => {
                    console.log(
                      `Resposta do PausarAgente: ${JSON.stringify(
                        resposta,
                        null,
                        2
                      )}`
                    );
                  }
                );
              },
              TirarPausa: (ramal) => {
                console.log(`Chamou TirarPausa para ramal ${ramal}`);
                io.emit("TirarPausaAgente", { ramal }, (resposta) => {
                  console.log(
                    `Resposta do Tirar pausa: ${JSON.stringify(
                      resposta,
                      null,
                      2
                    )}`
                  );
                });
              },
              RemoverAgente: (ramal, fila) => {
                console.log(
                  `Chamou RemoverAgente para ramal ${ramal} das filas: ${fila}`
                );
                io.emit("RemoverAgente", { ramal, fila }, (resposta) => {
                  console.log(
                    `Resposta do RemoverAgente: ${JSON.stringify(
                      resposta,
                      null,
                      2
                    )}`
                  );
                });
              },
              disconect: () => {
                io.disconnect();
              },
              filtraAtendimentosDuplicados: (resposta) => {
                return resposta.map((fila) => {
                  if (fila.AtendimentosAguardando) {
                    const seenAtendimentoIds = new Set();
                    fila.AtendimentosAguardando =
                      fila.AtendimentosAguardando.filter((atendimento) => {
                        if (
                          !seenAtendimentoIds.has(atendimento.atendimentoId)
                        ) {
                          seenAtendimentoIds.add(atendimento.atendimentoId);
                          return true;
                        }
                        return false;
                      });
                  }
                  if (fila.ligacoes_aguardando) {
                    const seenAtendimentoIds = new Set();
                    fila.ligacoes_aguardando = fila.ligacoes_aguardando.filter(
                      (atendimento) => {
                        if (!seenAtendimentoIds.has(atendimento.callid)) {
                          seenAtendimentoIds.add(atendimento.callid);
                          return true;
                        }
                        return false;
                      }
                    );
                  }
                  return fila;
                });
              },
              connect: action(function (user) {
                const userLocal = $localStorage.User;
                console.log(`Hora de conectar...`);
                io.connect();

                io.on("connect", () => {
                  console.log("Conectado no WS");
                  this.statusConexao = "conectado";
                  if (!userLocal.ldap) {
                    io.emit(
                      "login_adm",
                      { nome: user.nome, senha: user.senha },
                      (resposta) => {
                        console.log(
                          `Login resposta: ${JSON.stringify(resposta)}`
                        );
                        if (resposta.error) {
                          console.log(`Verifique os dados de acesso`);
                        } else {
                          // Login ok
                          console.log("Dae sim...logado");

                          io.emit("monitorar_filas", {}, (resposta) => {
                            // console.log(`monitorar_filas resposta: ${JSON.stringify(resposta)}`);
                            console.log(`monitorar_filas retornou`);
                          });

                          io.emit("getFilas", {}, async (resposta) => {
                            // console.log(`getFilas resposta: ${JSON.stringify(resposta)}`);
                            console.log(`getFilas retornou`);
                            this.filas = resposta;

                            this.populateAgentesList();
                          });
                        }
                      }
                    );
                  } else {
                    io.emit(
                      "login_adm_ldap",
                      { nome: user.nome, session_id: userLocal.session_id },
                      (resposta) => {
                        console.log(
                          `Login resposta: ${JSON.stringify(resposta)}`
                        );
                        if (resposta.error) {
                          console.log(`Verifique os dados de acesso`);
                        } else {
                          // Login ok
                          console.log("Dae sim...logado");

                          io.emit("monitorar_filas", {}, (resposta) => {
                            // console.log(`monitorar_filas resposta: ${JSON.stringify(resposta)}`);
                            console.log(`monitorar_filas retornou`);
                          });

                          io.emit("getFilas", {}, async (resposta) => {
                            // console.log(`getFilas resposta: ${JSON.stringify(resposta)}`);
                            console.log(`getFilas retornou`);

                            this.filas = resposta;
                            this.populateAgentesList();
                          });
                        }
                      }
                    );
                  }
                });
                // Agentes
                io.on("AgenteAdicionado", (agente) => {
                  console.log("AgenteAdicionado", agente);
                  this.addAgente(agente);
                });
                io.on("AgenteRemovido", (agente) => {
                  console.log("AgenteRemovido", agente);
                  this.delAgente(agente);
                });
                io.on("AgenteStatus", (agente) => {
                  console.log("AgenteStatus", agente);
                  this.updateAgente(agente);
                });
                io.on("AgenteLigacao", (ligacao) => {
                  console.log("AgenteLigacao", ligacao);
                  this.updateLigacaoAgente(ligacao);
                });

                // Fila
                io.on("FilaLigacaoAdicionada", (ligacao) => {
                  console.log("FilaLigacaoAdicionada", ligacao);
                  this.addAguardandoFila(ligacao);
                });
                io.on("FilaLigacaoAtendida", (ligacao) => {
                  console.log("FilaLigacaoAtendida", ligacao);
                  this.addAtendidaFila(ligacao);
                });
                io.on("FilaLigacaoTerminou", (ligacao) => {
                  console.log("FilaLigacaoTerminou", ligacao);
                  this.addFimLigacaoFila(ligacao);
                });
                io.on("FilaLigacaoAbandonou", (ligacao) => {
                  console.log("FilaLigacaoAbandonou", ligacao);
                  this.addAbandonoFila(ligacao);
                });
                io.on("FilaLigacaoTransbordou", (ligacao) => {
                  console.log("FilaLigacaoTransbordou", ligacao);
                  this.addTransbordoFila(ligacao);
                });

                // Omni
                io.on("FilaAtendimentoAguardandoAdicionado", (atendimento) => {
                  console.log(
                    "FilaAtendimentoAguardandoAdicionado",
                    atendimento
                  );
                  this.addAtendimentoAguardando(atendimento);
                });
                io.on("FilaAtendimentoAguardandoRemovido", (atendimento) => {
                  console.log("FilaAtendimentoAguardandoRemovido", atendimento);
                  this.delAtendimentoAguardando(atendimento);
                });
                io.on("FilaNovoAtendimento", (atendimento) => {
                  console.log("FilaNovoAtendimento", atendimento);
                  this.FilaNovoAtendimento(atendimento);
                });
                io.on("FilaNovaMensagem", (msg) => {
                  console.log("FilaNovaMensagem", msg);
                  this.FilaNovaMensagem(msg);
                });

                io.on("reconnect_attempt", () => {
                  console.log("reconnect_attempt");
                  this.statusConexao = "reconectando";
                });
                io.on("connect_failed", () => {
                  console.log("connect_failed");
                  this.statusConexao = "desconectado";
                });
                io.on("connect_error", () => {
                  console.log("connect_error");
                  this.statusConexao = "desconectado";
                });
                io.on("reconnect_failed", () => {
                  console.log("reconnect_failed");
                  this.statusConexao = "max_reconnect_error";
                });
                io.on("disconnect", () => {
                  console.log("Desconectou");
                  this.statusConexao = "desconectado";
                });
              }),
            });
          }
        }

        // create MobX shared store
        const ami = new Ami();
        return ami;
      },
    ];
  }
})();
